<?php
/********************************************************************
 * $Id: oracle.class.php,v 1.1.1.1 2008/10/13 06:13:37 winchild Exp $
 *
 * Name: oracle.class.php
 * Description: Oracle ͺ̽   ó Ŭ
 ********************************************************************/

ADOLoadCode("mssql");

class DB_Sql {
  var $Host     = "";
  var $Database = "";
  var $User     = "";
  var $Password = "";

  var $ADODB;
  var $RecordSet;
  var $Row	= -1;
  
  var $Errno    = 0;
  var $Error    = "";

  var $ForeceNew = false;
  
  
  /****************************************************************************
   * function DB_Sql()
   *
   * Visibility: public
   * Parameters: None
   * Return Values: None
   *
   * 
   ****************************************************************************/

  function DB_Sql() {

      $this->Host	= DB_HOST;
      $this->User	= DB_USER;
      $this->Password	= DB_PASSWORD;
      $this->Database	= DB_NAME;
  }


  /****************************************************************************
   * function connect($argHost="", $argUser="", $argPasswd="", $argDatabase="")
   *
   * Visibility: public
   * Parameters:
   *  - $argHost: ͺ̽ ȣƮ(ּ)
   *  - $argUser: ͺ̽  
   *  - $argPasswd: ͺ̽   ȣ
   *  - $argDatabase: ͺ̽ ̸
   * Return Values:
   *  - true / false
   *
   * ͺ̽ 
   ****************************************************************************/

  function connect($argHost = "", $argUser = "", $argPasswd = "", $argDatabase = "") {

    if ( $argHost != "" && $argUser != "" && $argPasswd != "" && $argDatabase != "" ) {
        $dsn = "oci8://" . $argUser . ":" . $argPasswd . "@" . $argHost . "/" . $argDatabase;
    } else {
        $dsn = "oci8://" . $this->User . ":" . $this->Password . "@" . $this->Host . "/" . $this->Database;
    }

    try {

      $this->ADODB = &ADONewConnection($dsn);

      return true;

    } catch(exception $e) {

      //var_dump($e);
      //adodb_backtrace($e->gettrace());

      return false;
    }
  }


  /****************************************************************************
   * function begin_trans()
   *
   * Visibility: public
   * Parameters: None
   * Return Values: None
   *
   * SQL Ʈ 
   ****************************************************************************/

  function begin_trans() {
    $this->ADODB->BeginTrans();
  }


  /****************************************************************************
   * function begin_trans()
   *
   * Visibility: public
   * Parameters: None
   * Return Values: None
   *
   * SQL    Ʈ ѹ 
   ****************************************************************************/

  function rollback_trans() {
    $this->ADODB->RollbackTrans();
  }


  /****************************************************************************
   * function commit_trans()
   *
   * Visibility: public
   * Parameters: None
   * Return Values: None
   *
   * SQL   Ϸ  Ʈ 
   ****************************************************************************/

  function commit_trans() {
    $this->ADODB->CommitTrans();
  }


  /****************************************************************************
   * function complete_trans()
   *
   * Visibility: public
   * Parameters: None
   * Return Values: None
   *
   * Ʈ  (SQL   Ǵ п Ͽ  ó )
   ****************************************************************************/

  function complete_trans() {
    $this->ADODB->CompleteTrans();
  }


  /****************************************************************************
   * function query($Query_String)
   *
   * Visibility: public
   * Parameters:
   *  - $Query_String:  SQL 
   *  - $BindingVars: ε  迭
   * Return Values:
   *  - true / false
   *
   * Binding ̿ SQL 
   ****************************************************************************/

  function query($Query_String, $BindingVars=false)
  {
    
    if ($Query_String == "") {
      return false;
    }

    $this->ADODB->SetFetchMode(ADODB_FETCH_ASSOC);

    try {

      $this->RecordSet = $this->ADODB->Execute($Query_String, $BindingVars);

    } catch (exception $e) {

      $this->RecordSet = false;
    }

    if ( $this->RecordSet === FALSE) {

      $this->Errno = $this->ADODB->ErrorNo();
      $this->Error = $this->ADODB->ErrorMsg();

      return false;

    } else {

      $this->Row = -1;

      return true;
    }
  }
  

  /****************************************************************************
   * function next_record()
   *
   * Visibility: public
   * Parameters: None
   * Return Values:
   *  - true / false
   *
   *     ڵ ̵
   ***************************************************************************/

  function next_record() {
    if ( $this->Row == -1 && !$this->RecordSet->EOF ) {
      $this->Row += 1;
      return true;
    } else if ( $this->RecordSet->MoveNext() ) {
      $this->Row = $this->RecordSet->CurrentRow();
      return true;
    } else {
      return false;
    }
  }


  /****************************************************************************
   * function move($pos)
   *
   * Visibility: public
   * Parameters:
   *  - $pos: ̵ ڵ ġ
   * Return Values:
   *  - true / false
   *
   *    Ư ڵ ̵
   ***************************************************************************/

  function move($pos) {
    return $this->RecordSet->Move($pos);
  }


  /****************************************************************************
   * function fetch_row()
   *
   * Visibility: public
   * Parameters: None
   * Return Values:
   *  - array
   *
   *  ڵ  迭 ȯ
   ***************************************************************************/

  function fetch_row() {
    return $this->RecordSet->FetchRow();
  }


  /****************************************************************************
   * function fetch_object()
   *
   * Visibility: public
   * Parameters: None
   * Return Values:
   *  - object
   *
   *  ڵ  Object ȯ
   ***************************************************************************/

  function fetch_object() {
    return $this->RecordSet->FetchObject();
  }

  /****************************************************************************
   * function fetch_next_object()
   *
   * Visibility: public
   * Parameters: None
   * Return Values:
   *  - object
   *
   * ڵ  ڵ ̵ϰ  ڵ  Object ȯ
   ***************************************************************************/

  function fetch_next_object() {
    return $this->RecordSet->FetchNextObject();
  }


  /****************************************************************************
   * function affected_rows()
   *
   * Visibility: public
   * Parameters: None
   * Return Values:
   *  - ó  
   *
   * Update / Insert    ó   ȯ
   ***************************************************************************/

  function affected_rows() {
    return $this->ADODB->Affected_Rows();
  }
  

  /****************************************************************************
   * function num_rows()
   *
   * Visibility: public
   * Parameters: None
   * Return Values:
   *  -    
   *
   * ˻    ȯ
   ***************************************************************************/

  function num_rows() {
    return $this->RecordSet->RecordCount();
  }
  
  /****************************************************************************
   * function num_fields()
   *
   * Visibility: public
   * Parameters: None
   * Return Values:
   *  - ڵ ʵ 
   *
   * ˻   ʵ  ȯ
   ***************************************************************************/

  function num_fields() {
    return $this->RecordSet->FieldCount();
  }

  /****************************************************************************
   * function nf()
   *
   * Visibility: public
   * Parameters: None
   * Return Values:
   *  -   
   *
   * num_rows()  
   ***************************************************************************/

  function nf() {
    return $this->num_rows();
  }
  

  /****************************************************************************
   * function np()
   *
   * Visibility: public
   * Parameters: None
   * Return Values: None
   *
   *    ȭ鿡 
   ***************************************************************************/

  function np() {
    print $this->num_rows();
  }
  

  /****************************************************************************
   * function f($Field_Name)
   *
   * Visibility: public
   * Parameters:
   *  - $Field_name: ʵ
   * Return Values:
   *  - ʵ 
   *
   *  ڵ忡 Ư ʵ  ȯ
   ***************************************************************************/

  function f($Field_Name) {
    return $this->RecordSet->Fields(strtoupper($Field_Name));
  }
  

  /****************************************************************************
   * function p($Field_Name)
   *
   * Visibility: public
   * Parameters:
   *  - $Field_name: ʵ
   * Return Values:
   *  - ʵ 
   *
   *  ڵ忡 Ư ʵ  
   ***************************************************************************/

  function p($Field_Name) {
    print $this->f($Field_Name);
  }
  

  /****************************************************************************
   * function close()
   *
   * Visibility: public
   * Parameters: None
   * Return Values: None
   *
   * ͺ̽κ  
   ***************************************************************************/

  function close() {
    if ( $this->RecordSet != null ) {
      $this->RecordSet->Close();
    }

    $this->ADODB->Close();
  }
}
?>
