<?php
/*
====================================================
	DomainCmd 

	 : ȣ 
	 : SockClient
	 :  ɾ ó Ŭ
====================================================
*/
class SockCmd extends SockClient
{
	public $cmd_sep = "";			//     
	public $ret_sep = "";				//     
	public $cmd_end = "\n";			//   Ÿ 

	// Error Message
	public $err_msg;

	// ************************************************
	// NAME : 
	// DESC :   IP PORT Ͽ  Ѵ.
	// ************************************************
	public function __construct($ip="", $port=0, $buf = 2048)
	{
		if (!empty($ip) && $port > 0)
		{
			parent::__construct ($ip, $port, $buf);
		}
	}

	// ************************************************
	// NAME :   
	// DESC : ɿ Ǵ  ڿ  ڿ ,   
	// ************************************************
	public function setCmdSep ($cmd_sep, $ret_sep, $cmd_end="\n")
	{
		$this->cmd_sep = $cmd_sep;
		$this->ret_sep = $ret_sep;
		$this->cmd_end = $cmd_end;
	}

	// ************************************************
	// NAME : ɾ 
	// DESC : 迭  ɾ ڿ ڸ  ü   ȯ
	//             Command + | + Parameter[0] + | + Parameter[n] + \n
	// ************************************************
	private function createCmd ($cmd_name, $arr_cmd)
	{
		if (count($arr_cmd) > 0)
		{
			return $cmd_name.$this->cmd_sep.implode($this->cmd_sep, $arr_cmd).$this->cmd_end;
		}
		else
		{
			return false;
		}
	}

	// ************************************************
	// NAME :   迭 ȯ
	// DESC : ڰ Ե   迭  ȯ
	//             Result Code + | + Item[0] + | + Item[n] + \n
	// ************************************************
	private function createRetToArr ($ret_val)
	{
		if (isset ($ret_val) && !empty($ret_val))
		{
			if (isset ($this->ret_sep) && !empty($this->ret_sep))
			{
				//  ڰ   ڸ  迭 ȯ
				return explode ($this->ret_sep, $ret_val);
			}
			else
			{
				//  ڰ  ϰ ״ ȯ
				return $ret_val;
			}
		}
		else
		{
			$this->err_msg = "  ϴ.";
			return false;
		}
	}

	// ************************************************
	//   :   ϰ  ״ ȯ Ѵ.
	// ************************************************
	public function execCmd ($cmd_name, $arr_parm)
	{
		if ( isset($cmd_name) && !empty($cmd_name) && count ($arr_parm) > 0 )
		{
			$cmd = $this->createCmd ($cmd_name,  $arr_parm);

			if ($cmd)
			{
				$ret = parent::sendTextCmd ($cmd);

				return $this->createRetToArr ($ret);
			}
			else
			{
				$this->err_msg = "߸ ɾ Դϴ.";
				return false;
			}
		}
		else
		{
			$this->err_msg = "ɾ   ߸ Ǿϴ.";
			return false;
		}
	}

	public function execCmdRaw ($cmd)
	{
		if ( isset($cmd) && !empty($cmd) )
		{
			$ret = parent::sendTextCmd ($cmd);

			return $ret;
		}
		else
		{
			return false;
		}				
	}

	// ************************************************
	//    ˻ :      ߴ  ߴ ˻ Ѵ.
	// ************************************************
	public function execCmdBool ($cmd_name, $arr_parm)
	{
		if ( isset($cmd_name) && !empty($cmd_name) && count ($arr_parm) > 0 )
		{
			$ret = $this->execCmd ($cmd_name, $arr_parm);

			if (!is_array ($ret))
			{
				if ($ret[0] == "0")
				{
					//   
					$this->err_msg = $ret;
					return false;
				}
				else
				{
					//  
					return $this->cmdOkChk($ret);
				}
			}
			else
			{
				$this->err_msg = "迭  Դϴ.";
				return false;
			}
		}
		else
		{
			$this->err_msg = "ɾ   ߸ Ǿϴ.";
			return false;
		}
	}

	// ************************************************
	//  ɾ ˻ :    ˻ (OK, TRUE  ˻)
	// ************************************************
	private function cmdOkChk($cmd_ret)
	{
		if (!empty($cmd_ret))
		{
			$accept_msg = array ("OK", "TRUE", "ACCEPT");
			$up_cmd_ret = strtoupper ($cmd_ret);
			
			foreach ($accept as $msg)
			{
				if (substr($up_cmd_ret, 0, strlen($msg)) == $msg)
				{
					return true;
				}
			}

			$this->err_msg = $cmd_ret;
			return false;
		}
		else
		{
			$this->err_msg = " ϴ.";
			return false;
		}
	}
}




?>