<?php

//
//	$Id: xml2Array.php,v 1.1.1.1 2008/10/13 06:13:38 winchild Exp $
//
//	NAME: XML파싱 및 GET컬럼
//	ARGUMENT:
//	DESCRIPTION:
//		HSM 에서 던져주는 데이터를 파싱하고 컬럼명으로 가져오기
//
//	REFERENCE:
//		http://kr.php.net/manual/kr/function.xml-parse.php 에서 입수
//

/* Usage
 Grab some XML data, either from a file, URL, etc. however you want. Assume storage in $strYourXML;

 $objXML = new xml2Array();
 $arrOutput = $objXML->parse($strYourXML);
 print_r($arrOutput); //print it out, or do whatever!
 
*/
class xml2Array {
  
   var $arrOutput = array();
   var $resParser;
   var $strXmlData;
  
   function parse($strInputXML) {
  
           $this->resParser = xml_parser_create ();
           xml_set_object($this->resParser,$this);
           xml_set_element_handler($this->resParser, "tagOpen", "tagClosed");
          
           xml_set_character_data_handler($this->resParser, "tagData");
      
           $this->strXmlData = xml_parse($this->resParser,$strInputXML );
           if(!$this->strXmlData) {
               die(sprintf("XML error: %s at line %d",
           xml_error_string(xml_get_error_code($this->resParser)),
           xml_get_current_line_number($this->resParser)));
           }
                          
           xml_parser_free($this->resParser);
          
           return $this->arrOutput;
   }
   function tagOpen($parser, $name, $attrs) {
       $tag=array("name"=>$name,"attrs"=>$attrs);
       array_push($this->arrOutput,$tag);
   }
  
   function tagData($parser, $tagData) {
       if(trim($tagData)) {
           if(isset($this->arrOutput[count($this->arrOutput)-1]['tagData'])) {
               $this->arrOutput[count($this->arrOutput)-1]['tagData'] .= $tagData;
           }
           else {
               $this->arrOutput[count($this->arrOutput)-1]['tagData'] = $tagData;
           }
       }
   }
  
   function tagClosed($parser, $name) {
       $this->arrOutput[count($this->arrOutput)-2]['children'][] = $this->arrOutput[count($this->arrOutput)-1];
       array_pop($this->arrOutput);
   }
}

// 컬럼데이터 가져오기
//
function xml_get_column ($arr, $name)
{
	for ($i=0; $i<count($arr[0]["children"]); $i++)
	{
		if (isset($arr[0]["children"][$i]["attrs"]["NAME"]) &&
			$arr[0]["children"][$i]["attrs"]["NAME"] == $name)
			return $arr[0]["children"][$i]["tagData"];
	}
}

?>

