<?
//
//	$Id: arp_list.php,v 1.1.1.1 2008/10/13 06:13:37 winchild Exp $
//
//	NAME: arp_put
//	ARGUMENT:
//	DESCRIPTION:
//		L3 ARP 전체목록
//
//	REFERENCE:
//		mysql> desc L3host;
//		+----------+-------------+------+-----+---------+-------+
//		| Field    | Type        | Null | Key | Default | Extra |
//		+----------+-------------+------+-----+---------+-------+
//		| ip       | varchar(20) | NO   | PRI |         |       |
//		| name     | varchar(32) | YES  |     | NULL    |       |
//		| host_id  | int(11)     | YES  |     | NULL    |       |
//		| comunity | varchar(16) | YES  |     | NULL    |       |
//		| ts       | datetime    | YES  |     | NULL    |       |
//		+----------+-------------+------+-----+---------+-------+
//		5 rows in set (0.01 sec)
//		
//		mysql> desc dup_mac;
//		+-------+-------------+------+-----+---------+-------+
//		| Field | Type        | Null | Key | Default | Extra |
//		+-------+-------------+------+-----+---------+-------+
//		| mac   | varchar(32) | NO   | PRI |         |       |
//		| l3ip  | varchar(20) | NO   |     |         |       |
//		| ip    | varchar(20) | YES  |     | NULL    |       |
//		| vlan  | varchar(10) | NO   |     |         |       |
//		| memo  | tinytext    | YES  |     | NULL    |       |
//		| ts    | datetime    | YES  |     | NULL    |       |
//		+-------+-------------+------+-----+---------+-------+
//		6 rows in set (0.00 sec)
//
//		mysql> desc sj_mac_ip;
//		+---------+---------------------------+------+-----+---------+----------------+
//		| Field   | Type                      | Null | Key | Default | Extra          |
//		+---------+---------------------------+------+-----+---------+----------------+
//		| sid     | int(11)                   | NO   | PRI | NULL    | auto_increment |
//		| mac     | varchar(32)               | NO   |     |         |                |
//		| ip      | varchar(16)               | NO   |     |         |                |
//		| status  | enum('N','U','E','D','A') | NO   |     |         |                |
//		| idx_sid | int(11)                   | NO   |     |         |                |
//		| L3_ip   | varchar(16)               | NO   |     |         |                |
//		| vlan    | int(11)                   | NO   |     |         |                |
//		+---------+---------------------------+------+-----+---------+----------------+
//		7 rows in set (0.00 sec)
//
//		mysql> desc account;
//		+-----------+---------------+------+-----+---------------------+----------------+
//		| Field     | Type          | Null | Key | Default             | Extra          |
//		+-----------+---------------+------+-----+---------------------+----------------+
//		| sid       | int(11)       | NO   | PRI | NULL                | auto_increment |
//		| gid       | int(11)       | NO   | UNI |                     |                |
//		| ip        | varchar(16)   | NO   | MUL |                     |                |
//		| svc_no    | varchar(6)    | NO   |     |                     |                |
//		| name      | tinytext      | YES  |     | NULL                |                |
//		| wkid      | varchar(6)    | NO   |     |                     |                |
//		| ts        | datetime      | NO   |     | 0000-00-00 00:00:00 |                |
//		| limit_cnt | int(11)       | YES  |     | NULL                |                |
//		| pause     | enum('Y','N') | YES  |     | N                   |                |
//		+-----------+---------------+------+-----+---------------------+----------------+
//		9 rows in set (0.00 sec)
//
//		mysql> desc ip_desc;
//		+--------+-------------+------+-----+---------------------+-------+
//		| Field  | Type        | Null | Key | Default             | Extra |
//		+--------+-------------+------+-----+---------------------+-------+
//		| ip     | varchar(15) | NO   | PRI |                     |       |
//		| memo   | tinytext    | NO   |     |                     |       |
//		| reg_id | varchar(10) | NO   |     |                     |       |
//		| ts     | datetime    | NO   |     | 0000-00-00 00:00:00 |       |
//		+--------+-------------+------+-----+---------------------+-------+
//		4 rows in set (0.03 sec)
//

	require_once("./config.php");
	require_once("../include/config.php");
	require_once("DIRECTLIB/adodb/adodb.inc.php");
	require_once("DIRECTLIB/include/db.php");

	$db = db_conn ($database_type, $database_hostname, $database_username, $database_password, $database_default);
	if ($db === false)
	{
		die ("connect faild");
	}

	if (isset($_POST["submit"]) && $_POST["submit"] == "저장")
	{
		$query = "REPLACE vlan_desc (l3_ip,vlan,base_ip,mask,ts) VALUE ".
		"('".$_GET["ip"]."','".$_GET["vlan"]."','".$_POST["base_ip"]."','".$_POST["mask"]."',NOW())";
		if ($db->Execute ($query) === false) die ("SQL=[$query] : Error");
	}

	$base_ip = $mask = "";
	if (isset($_GET["ip"]))
	{
		$query = "SELECT base_ip,mask FROM vlan_desc WHERE l3_ip='".$_GET["ip"]."' AND vlan='".$_GET["vlan"]."'";
		if (($temp = get_array($db, $query)) !== false)
		{
			$base_ip = $temp[0]["base_ip"];
			$mask = $temp[0]["mask"];
		}
	}

	// SNMPWALK PATH
	$query = "SELECT value FROM settings WHERE name='path_snmpwalk'";
	if (($L3_arr = get_array($db, $query)) == false) die ("path_snmpwalk invalid.");
	$path_snmpwalk = $L3_arr[0]["value"] . SNMPWALK_OPTION;

	// L3 FETCH.
	$query = "SELECT ip, name, comunity FROM L3host ORDER BY name";
	if (($L3_arr = get_array($db, $query)) == false) $L3_arr = array ();

	//	해당 장비의 VAN 에 속한 IP 대역을 FETCH
	$desc_arr = array();
	for ($i=0; $i<count($L3_arr); $i++)
	{
		get_desc ($L3_arr[$i]["ip"], $db, $L3_arr[$i]["comunity"]);
//print_r ($desc_arr[$L3_arr[$i]["ip"]]);
	}

	$et=time(); $st=$et-(3600*24);

?>
<html>
<head>
<title>L3 MAC List - Samjung Data Service Network Admin</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv=refresh content='300'>
<link rel="stylesheet" type="text/css" href="style.css" />
<!--script type="text/javascript" src="./utils_lib.js"></script>
<script type="text/javascript" src="./ajax_lib.js"></script>
<script type="text/javascript" src="./xml_lib.js"></script-->
<script language="javascript">
<!--
function arp_list (ip, vlan)
{
	document.location = "arp_list.php?ip="+ip+"&vlan="+vlan;
}

function arp_list_all (ip)
{
	document.location = "arp_list.php?ip="+ip+"&vlan="+vlan;
}

function gr_open (gid)
{
	window.open("../graph_image.php?local_graph_id="+gid+"&rra_id=0&view_type=tree&graph_start=<?=$st?>&graph_end=<?=$et?>",
	"graph", "width=500,height=240");
}

function mac_mark (l3ip, ip, mac, vlan)
{
	window.open("mac_mark.php?l3ip="+l3ip+"&ip="+ip+"&mac="+mac+"&vlan="+vlan, "mac_mark", "width=500,height=240");
}

function write_desc (l3ip,vlan,ip,n)
{
	if (n == 0 || n == 255)
	{
		alert ("끝자리가 '0' 이거나 '255' 인 ip 는 할당할 수 없습니다.");
		return;
	}
	window.open("write_ip_desc.php?l3ip="+l3ip+"&ip="+ip+"&vlan="+vlan, "ip_desc", "width=500,height=140");
}

-->
</script>
</head>
<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<? require_once ("cacti_head.php") ?>
<br>
<div align="left" style="margin-left:10px;">
<table width="90%" border=0>
 <tr>
  <td align="left">
    <font size="3"><b>MAC LIST</b></font>
	[<a href="arp_put.php">전체목록</a>] [<a href="arp_list.php">초기목록</a>]
  </td>
 </tr>
</table>
<table width="98%" border="0" bgcolor="gainsboro">
<form method="post" name="arp_put" action="arp_put.php">
  <tr bgcolor="#3154a5" height="24" align="center">
    <td width="20"><font color="white">NO</font></td>
    <td width="100"><font color="white">IP</font></td>
    <td width="80"><font color="white">NAME</font></td>
    <td colspan="2"><font color="white">LIST</font></td>
  </tr>
<?
	for ($i=0; $i<count($L3_arr); $i++)
	{
?>
  <tr bgcolor="white">
	<td align="center"><?=($i+1)?></td>
	<td align="center"><?=$L3_arr[$i]["ip"]?></td>
	<td align="center"><?=$L3_arr[$i]["name"]?></td>
	<td align="center">
		<input type="button" name="all_<?=$i?>" value="All" OnClick="arp_list('<?=$L3_arr[$i]["ip"]?>','')">
	</td>
	<td align="left">
			<table width="100%">
			<tr>
<?
		$ridx = 0;
		foreach ($desc_arr[$L3_arr[$i]["ip"]] as $vlan => $name)
		{
			// 해당 VLAN/ 의 수고 갯수를 FETCH
			$query = "SELECT COUNT(*) AS count FROM ip_table WHERE L3_ip='".$L3_arr[$i]["ip"]."' AND vlan='$vlan'";
			if (($t_arr = get_array($db, $query)) === false) $count = 0;
			$count = $t_arr[0]["count"];

			$b_ip = $b_mask = "";
			$query = "SELECT base_ip,mask FROM vlan_desc WHERE l3_ip='".$L3_arr[$i]["ip"]."' AND vlan='$vlan'";
			if (($t_arr = get_array($db, $query)) !== false)
			{
				$b_ip = $t_arr[0]["base_ip"];
				$b_mask = $t_arr[0]["mask"];
				$b_mask_no = count_mask ($b_mask);
			}
?>
			<td width="200">
			<input type="button" name="<?=$vlan?>" value="<?=$name["name"]?>"
				OnClick="arp_list('<?=$L3_arr[$i]["ip"]?>','<?=$vlan?>')">
		<?=$desc_arr[$L3_arr[$i]["ip"]][$vlan]["sip"]?> ~
		<?=substr($desc_arr[$L3_arr[$i]["ip"]][$vlan]["eip"],strrpos($desc_arr[$L3_arr[$i]["ip"]][$vlan]["eip"],'.')+1)?> <font color="blue">(<b><?=$count?></b>) <?=($b_ip ? "$b_ip/$b_mask_no":"")?></font>
			</td>
<?
			if ($ridx % 2) echo "</tr>\n<tr>";
			$ridx++;
		}
?>
			</td>
			</tr>
			</table>
	</td>
  </tr>
<?
	}
?>
</form>
</table>
<br>
(주1) MAC 클릭시 중복을 허용하는 메시지를 입력할 수 있음.<br>
(주2) GID 클릭시 해당 스위치포트의 트래픽 그래프를 확인할 수 있음<br>
(주3) DESCRIPTION 클릭시 IP 해당하는 설명을 입력할 수 있음<br>
<?
	if (!empty($_GET["ip"]))
	{
		/////////////// 해당 L3 스위치와 VLAN을 지정한 경우

		$total_no = 0;


		if ($base_ip && $mask)
		{

			///////////// base_ip 와 mask 가 지정된 경우.

		$ip_arr = array();

		$arr = explode ('.', $base_ip);
		$st_no = $arr[3];
		$temp = $arr[0].".".$arr[1].".".$arr[2].".";
		$arr = explode ('.', $mask);
		$end_no = $st_no + $arr[3];
		for ($i=$st_no; $i<$end_no; $i++)
		{
			$ip_arr[$i]["ip_addr"] = $temp . $i;	// 사용하는 주소 배정
			$ip_arr[$i]["dup_flag"] = false;
			$ip_arr[$i]["mac_addr"] = "";
			$ip_arr[$i]["vlan"] = "";
		}

		// 커뮤니티 탐색
		$comunity = get_comunity ($_GET["ip"]);
		if ($comunity == false)
		{
			echo __FILE__."(".__LINE__."): comunity get faild. ip=[".$_GET["ip"]."]";
			exit;
		}

		// 스위치에서 IP 및 MAC 목록을 로딩
		if (empty($_GET["vlan"])) $cmd = $path_snmpwalk ."-c $comunity ".$_GET["ip"]." ".ARP_MAC_OID;
		else $cmd = $path_snmpwalk . "-c $comunity ".$_GET["ip"]." ".ARP_MAC_OID.".".$_GET["vlan"].".1";

		if (($fp = popen ($cmd, "r")) == false)
		{
			echo __FILE__."(".__LINE__."): execution error. cmd=[$cmd]";
			exit;
		}
//echo __FILE__."(".__LINE__."): cmd=[$cmd]";

		$arp = array();
		$idx = 0;
		while (!feof ($fp))
		{
			$buffer = fgets ($fp, 256);
			if (strlen($buffer) < 2) break;
//			echo __FILE__."(".__LINE__."): buffer=[$buffer]";
// .1.3.6.1.2.1.3.1.1.2.100.1.211.115.209.170 = Hex-STRING: 00 12 F2 3B B1 00
			$i = strpos ($buffer, ":");
			$mac_addr = trim(substr ($buffer, $i+1));	// blank skip.
			$i = strpos ($buffer, "=");
			$temp = substr ($buffer, 0, $i);
			$ip_array = explode (".", $temp);
//print_r ($ip_arr);
//		echo __FILE__."(".__LINE__."): buffer=[$buffer]";
			if (!isset($ip_array[IP_OFFSET])) continue;
			$ip_addr = trim($ip_array[IP_OFFSET].".".$ip_array[IP_OFFSET+1].".".$ip_array[IP_OFFSET+2].".".$ip_array[IP_OFFSET+3]);
			$vlan = trim($ip_array[VLAN_OFFSET]);

			for ($i=$st_no; $i<$end_no; $i++)
			{
				if ($ip_arr[$i]["ip_addr"] == $ip_addr) break;
			}
			if ($i < $end_no)
			{
				$ip_arr[$i]["vlan"] = $vlan;
				$ip_arr[$i]["mac_addr"] = $mac_addr;
			}


			$ip_arr[$i]["dub_flag"] = dup_check($mac_addr, $idx); // 중복여부 체크

			// 주소 목록, 전후 관계를 파악하기 위하여 필요
			$arp[$idx]["mac"] = $mac_addr;
			$arp[$idx]["ip"] = $ip_addr;
			$idx++;
		}
		$total_no += $idx;

?>
<form method="post" name="ip_mask" action="arp_list.php?ip=<?=$_GET["ip"]?>&vlan=<?=$_GET["vlan"]?>">
<h2><?=get_L3_name($_GET["ip"])?> (<?=$_GET["ip"]?>) <?=(empty($_GET["vlan"])?"":"Vlan".$_GET["vlan"])?></h2>
<b>IP:</b> <input type="text" name="base_ip" size="15" maxlength="15" value="<?=$base_ip?>">
<b>MASK:</b> <input type="text" name="mask" size="15" maxlength="15" value="<?=$mask?>"> <input type="submit" name="submit" value="저장"> </h2>
</form>
<table width="98%" border="0" bgcolor="#EFEFEF">
  <tr bgcolor="#3154a5" height="24" align="center">
    <td width="32"><font color="white">NO</font></td>
    <td width="100"><font color="white">IP</font></td>
    <td width="50"><font color="white">VLAN</font></td>
    <td width="150"><font color="white">MAC</font></td>
    <td width="50"><font color="white">SVCNO</font></td>
    <td width="50"><font color="white">GID</font></td>
    <td width="*"><font color="white">NAME</font></td>
    <!--td width="*"><font color="white">TITLE</font></td 사용하지 않음 -->
    <td width="*"><font color="white">DUP MEMO</font></td>
    <td width="*"><font color="white">DESCRIPTION</font></td>
  </tr>
<?

		// ROW 출력
		$no = 1;
		for ($i=$st_no; $i<$end_no; $i++)
		{

			$memo = "";
			if ($ip_arr[$i]["dup_flag"])
			{
				// 중복을 허용한 MAC 인지 확인
				$query = "SELECT memo FROM dup_mac WHERE mac='".$ip_arr[$i]["$mac_addr"]."'";
				if (($tmp_arr = get_array($db, $query)) === false)
				{
					$bgcolor = "orange";	// 중복되었음
				}
				else
				{
					$bgcolor = "gainsboro";
					$memo = $tmp_arr[0]["memo"];
				}
			}
			else
			{
				if ($ip_arr[$i]["mac_addr"] != "") $bgcolor = "white";
				else $bgcolor = "#ffff99";

				$RM_ip = substr($ip_arr[$i]["ip_addr"], strrpos($ip_arr[$i]["ip_addr"],'.')+1);
				if ($RM_ip == 0 || $RM_ip == 255) $bgcolor = "gainsboro";
			}

			// 고객정보 FETCH
			$query = "SELECT svc_no,name,gid FROM account WHERE ip='".$ip_arr[$i]["ip_addr"]."'";
			if (($acct_arr = get_array($db, $query)) !== false)
			{
				$name = $acct_arr[0]["name"];
				$svc_no = $acct_arr[0]["svc_no"];
				$gid = $acct_arr[0]["gid"];
			}
			else $name = $svc_no = $gid = "";

			// IP 용도를 기록한 메모
			$query = "SELECT memo FROM ip_desc WHERE ip='".$ip_arr[$i]["ip_addr"]."'";
			if (($tmp_arr = get_array($db, $query)) !== false) $ip_desc = $tmp_arr[0]["memo"];
			else	$ip_desc = "";
?>
  <tr bgcolor="<?=$bgcolor?>">
	<td align="center"><?=($no++)?></td>
	<td align="center"><?=$ip_arr[$i]["ip_addr"]?></td>
	<td align="center"><?=$desc_arr[$_GET["ip"]][$vlan]["name"]?></td>
	<td align="center"><a
href="javascript:mac_mark('<?=$_GET["ip"]?>','<?=$ip_arr[$i]["ip_addr"]?>','<?=$ip_arr[$i]["mac_addr"]?>','<?=$ip_arr[$i]["vlan"]?>')"><?=$ip_arr[$i]["mac_addr"]?></a></td>
	<td align="center"><?=$svc_no?></td>
	<td align="center"><a href="javascript:gr_open(<?=$gid?>)"><?=$gid?></a></td>
	<td align="left"><?=$name?></td>
	<td align="left"><?=$memo?>&nbsp;</td>
	<td align="left" OnClick="write_desc('<?=$_GET["ip"]?>','<?=$ip_arr[$i]["vlan"]?>','<?=$ip_arr[$i]["ip_addr"]?>',<?=$RM_ip?>)"><?=$ip_desc?>&nbsp;</td>
  </tr>
<?
		}
?>
</table>
<?
		}
		else
		{


		////////////// IP 와 MASK 가 지정되지 않은 경우 ///////////

		// 결국에는 IP 와 MASK 가 지정되어야 하므로 나중에는 삭제될 부분임.
?>
<h2><?=get_L3_name($_GET["ip"])?> (<?=$_GET["ip"]?>:<?=(empty($_GET["vlan"])?"":"Vlan".$_GET["vlan"])?>)</h2>
<form method="post" name="ip_mask" action="arp_list.php?ip=<?=$_GET["ip"]?>&vlan=<?=$_GET["vlan"]?>">
<b>IP:</b> <input type="text" name="base_ip" size="15" maxlength="15" value="<?=$base_ip?>">
<b>MASK:</b> <input type="text" name="mask" size="15" maxlength="15" value="<?=$mask?>"> <input type="submit" name="submit" value="저장"> </h2>
</form>
<table width="98%" border="0" bgcolor="#EFEFEF">
  <tr bgcolor="#3154a5" height="24" align="center">
    <td width="32"><font color="white">NO</font></td>
    <td width="100"><font color="white">IP</font></td>
    <td width="50"><font color="white">VLAN</font></td>
    <td width="150"><font color="white">MAC</font></td>
    <td width="50"><font color="white">SVCNO</font></td>
    <td width="50"><font color="white">GID</font></td>
    <td width="*"><font color="white">NAME</font></td>
    <td width="*"><font color="white">DUP MEMO</font></td>
    <td width="*"><font color="white">DESCRIPTION</font></td>
  </tr>
<?
		// 커뮤니티 탐색
		$comunity = get_comunity ($_GET["ip"]);
		if ($comunity == false)
		{
			echo __FILE__."(".__LINE__."): comunity get faild. ip=[".$_GET["ip"]."]";
			exit;
		}

		// 스위치에서 IP 및 MAC 목록을 로딩
		if (empty($_GET["vlan"])) $cmd = $path_snmpwalk ."-c $comunity ".$_GET["ip"]." ".ARP_MAC_OID;
		else $cmd = $path_snmpwalk . "-c $comunity ".$_GET["ip"]." ".ARP_MAC_OID.".".$_GET["vlan"].".1";

		if (($fp = popen ($cmd, "r")) == false)
		{
			echo __FILE__."(".__LINE__."): execution error. cmd=[$cmd]";
			exit;
		}
//echo __FILE__."(".__LINE__."): cmd=[$cmd]";

		$arp = array();
		$idx = 0;
		$no = 1;
		while (!feof ($fp))
		{
			$buffer = fgets ($fp, 256);
			if (strlen($buffer) < 2) break;
//			echo __FILE__."(".__LINE__."): buffer=[$buffer]";
// .1.3.6.1.2.1.3.1.1.2.100.1.211.115.209.170 = Hex-STRING: 00 12 F2 3B B1 00
			$n = strpos ($buffer, ":");
			$mac_addr = trim(substr ($buffer, $n+1));	// blank skip.
			$n = strpos ($buffer, "=");
			$temp = substr ($buffer, 0, $n);
			$ip_arr = explode (".", $temp);
//print_r ($ip_arr);
//		echo __FILE__."(".__LINE__."): buffer=[$buffer]";
			if (!isset($ip_arr[IP_OFFSET])) continue;
			$ip_addr = trim($ip_arr[IP_OFFSET].".".$ip_arr[IP_OFFSET+1].".".$ip_arr[IP_OFFSET+2].".".$ip_arr[IP_OFFSET+3]);
			$vlan = trim($ip_arr[VLAN_OFFSET]);


  			$dup_flag = dup_check($mac_addr, $idx); // 중복여부 체크
			$memo = "";

			if ($dup_flag)
			{
				// 중복을 허용한 MAC 인지 확인
				$query = "SELECT memo FROM dup_mac WHERE mac='$mac_addr'";
				if (($tmp_arr = get_array($db, $query)) === false)
				{
					$bgcolor = "orange";	// 중복되었음
				}
				else
				{
					$bgcolor = "gainsboro";
					$memo = $tmp_arr[0]["memo"];
				}
			}
			else $bgcolor = "white";

			$digit = ($ip_arr[IP_OFFSET+2] * 256) + $ip_arr[IP_OFFSET+3];
			if ($idx > 0)
			{
				$n = abs($arp[$idx-1]["digit"] - $digit);
//echo "DIGIT=[".$arp[$idx-1]["digit"]."]/[$digit]=[$n]<br>";
			}
			else $n = 1;

			if ($n > 1 && $n < 256)
			{
				// 비어있는 IP 목록 표기
				$j = (substr($arp[$idx-1]["ip"],strrpos($arp[$idx-1]["ip"],'.')+1)) + 1;
				for (; $j<$ip_arr[IP_OFFSET+3] && $j<256; $j++)
				{
//echo "j=[$j],\$ip_arr[IP_OFFSET+3]=[".$ip_arr[IP_OFFSET+3]."]";
					$ip_addr_empty = $ip_arr[IP_OFFSET].".".$ip_arr[IP_OFFSET+1].".".$ip_arr[IP_OFFSET+2].".$j";

					// 고객정보 FETCH
					$query = "SELECT svc_no,name,gid FROM account WHERE ip='$ip_addr_empty'";
					if (($acct_arr = get_array($db, $query)) !== false)
					{
						$name = $acct_arr[0]["name"];
						$svc_no = $acct_arr[0]["svc_no"];
						$gid = $acct_arr[0]["gid"];
					}
					else $name = $svc_no = $gid = "";

					// IP 용도를 기록한 메모
					$query = "SELECT memo FROM ip_desc WHERE ip='$ip_addr_empty'";
					if (($tmp_arr = get_array($db, $query)) !== false) $ip_desc = $tmp_arr[0]["memo"];
					else	$ip_desc = "";

?>
  <tr bgcolor="#ffff99">
	<td align="center"><?=($no++)?></td>
	<td align="center"><?=$ip_addr_empty?></td>
	<td align="center">&nbsp;</td>
	<td align="center">&nbsp;</td>
	<td align="center">&nbsp;</a></td>
	<td align="left">&nbsp;</td>
	<td align="left">&nbsp;</td>
	<td align="left">&nbsp;</td>
	<td align="left" OnClick="write_desc('<?=$_GET["ip"]?>','<?=$vlan?>','<?=$ip_addr_empty?>')"><?=$ip_desc?>&nbsp;</td>
  </tr>
<?
				}	// of for()
			}	// of if ()

			// 고객정보 FETCH
			$query = "SELECT svc_no,name,gid FROM account WHERE ip='$ip_addr'";
			if (($acct_arr = get_array($db, $query)) !== false)
			{
				$name = $acct_arr[0]["name"];
				$svc_no = $acct_arr[0]["svc_no"];
				$gid = $acct_arr[0]["gid"];
			}
			else $name = $svc_no = $gid = "";

			// IP 용도를 기록한 메모
			$query = "SELECT memo FROM ip_desc WHERE ip='$ip_addr'";
			if (($tmp_arr = get_array($db, $query)) !== false) $ip_desc = $tmp_arr[0]["memo"];
			else	$ip_desc = "";

?>
  <tr bgcolor="<?=$bgcolor?>">
	<td align="center"><?=($no++)?></td>
	<td align="center"><?=$ip_addr?></td>
	<td align="center"><?=$desc_arr[$_GET["ip"]][$vlan]["name"]?></td>
	<td align="center"><a
href="javascript:mac_mark('<?=$_GET["ip"]?>','<?=$ip_addr?>','<?=$mac_addr?>','<?=$vlan?>')"><?=$mac_addr?></a></td>
	<td align="center"><?=$svc_no?></td>
	<td align="center"><a href="javascript:gr_open(<?=$gid?>)"><?=$gid?></a></td>
	<td align="left"><?=$name?></td>
	<td align="left"><?=$memo?>&nbsp;</td>
	<td align="left" OnClick="write_desc('<?=$_GET["ip"]?>','<?=$vlan?>','<?=$ip_addr?>')"><?=$ip_desc?>&nbsp;</td>
  </tr>
<?
			// 주소 목록, 전후 관계를 파악하기 위하여 필요
			$arp[$idx]["mac"] = $mac_addr;
			$arp[$idx]["ip"] = $ip_addr;
			$arp[$idx]["digit"] = $digit;
			$idx++;
		}
		$total_no += $idx;
?>
</table>
<?
	}	// of ////////////// IP 와 MASK 가 지정되지 않은 경우 ///////////

	}
	else
	{
		// 스위치 전체의 요약정보 (중복된 IP만 출력)
?>
</div>
<p>&nbsp;</p>
<div align="left" style="margin-left:10px;">
<table width="90%" border=0>
 <tr>
  <td align="left">
    <font size="3"><b>DUP MAC LIST</b> <input type="button" name="refresh" value="refresh"
	OnClick="document.location='arp_list.php'"></font>
  </td>
 </tr>
</table>
<!--form method="post" name="arp_put" action="arp_put.php" enctype="multipart/form-data"-->
<?
	$total_no = 0;

	for ($i=0; $i<count($L3_arr); $i++)
	{
?>
<p>
<b><?=$L3_arr[$i]["name"]?> (<?=$L3_arr[$i]["ip"]?>)</b>
<table width="90%" border="0" bgcolor="gainsboro">
  <tr bgcolor="#3154a5" height="24" align="center">
    <td width="32" rowspan="2"><font color="white">NO</font></td>
    <td width="50" rowspan="2"><font color="white">VLAN</font></td>
    <td width="150" rowspan="2"><font color="white">MAC</font></td>
    <td width="*" colspan="4"><font color="white">DUP IP</font></td>
    <td width="*" colspan="4"><font color="white">ORIG IP</font></td>
  </tr>
  <tr bgcolor="#3154a5" height="24" align="center">
    <td width="100"><font color="white">IP</font></td>
    <td width="50"><font color="white">SVCNO</font></td>
    <td width="50"><font color="white">GID</font></td>
    <td width="*"><font color="white">NAME</font></td>
    <td width="100"><font color="white">IP</font></td>
    <td width="50"><font color="white">SVCNO</font></td>
    <td width="50"><font color="white">GID</font></td>
    <td width="*"><font color="white">NAME</font></td>
  </tr>
<?
		$cmd = $path_snmpwalk." -c ".$L3_arr[$i]["comunity"]." ".$L3_arr[$i]["ip"]." ".ARP_MAC_OID;
		if (($fp = popen ($cmd, "r")) == false)
		{
			echo __FILE__."(".__LINE__."): execution error. cmd=[$cmd]";
			exit;
		}
//		echo __FILE__."(".__LINE__."): cmd=[$cmd]";

		$arp = array();
		$idx = 0;
		while (!feof ($fp))
		{
			$buffer = fgets ($fp, 256);
			if (strlen($buffer) < 2) break;
//			echo __FILE__."(".__LINE__."): buffer=[$buffer]";
// .1.3.6.1.2.1.3.1.1.2.100.1.211.115.209.170 = Hex-STRING: 00 12 F2 3B B1 00
			$n = strpos ($buffer, ":");
			$mac_addr = trim(substr ($buffer, $n+1));	// blank skip.
			$n = strpos ($buffer, "=");
			$temp = substr ($buffer, 0, $n);
			$ip_arr = explode (".", $temp);
//print_r ($ip_arr);
			$ip_addr = $ip_arr[IP_OFFSET].".".$ip_arr[IP_OFFSET+1].".".$ip_arr[IP_OFFSET+2].".".$ip_arr[IP_OFFSET+3];
			$vlan = $ip_arr[VLAN_OFFSET];

			$name = "";
			$svc_no = "";
			$gid = "";

  			$dup_no = dup_check($mac_addr, $idx);
			if ($dup_no == false)
			{
				// 중복을 체크하기 위해서 목록화.
				$arp[$idx]["mac"] = $mac_addr;
				$arp[$idx]["ip"] = $ip_addr;
				$idx++;
				continue;
			}

			// 중복허용 IP 체크.
			$query = "SELECT 1 FROM dup_mac WHERE mac='$mac_addr'";
			if (get_array($db, $query) !== false) continue;	// DUP ALLOWED

			$name[0] = $svc_no[0] = $gid[0] = "";
			$query = "SELECT svc_no,name,gid FROM account WHERE ip='$ip_addr'";
			if (($acct_arr = get_array($db, $query)) !== false)
			{
				$name[0] = $acct_arr[0]["name"];
				$svc_no[0] = $acct_arr[0]["svc_no"];
				$gid[0] = $acct_arr[0]["gid"];
			}

			$name[1] = $svc_no[1] = $gid[1] = "";
			$query = "SELECT svc_no,name,gid FROM account WHERE ip='".$arp[$dup_no]["ip"]."'";
			if (($acct_arr = get_array($db, $query)) !== false)
			{
				$name[1] = $acct_arr[0]["name"];
				$svc_no[1] = $acct_arr[0]["svc_no"];
				$gid[1] = $acct_arr[0]["gid"];
			}
?>
  <tr height="24" bgcolor="orange">
	<td align="center"><?=($no++)?></td>
	<td align="center"><?=$desc_arr[$L3_arr[$i]["ip"]][$vlan]["name"]?></td>
	<td align="center"><a
href="javascript:mac_mark('<?=$L3_arr[$i]["ip"]?>','<?=$ip_addr?>','<?=$mac_addr?>','<?=$vlan?>')"><?=$mac_addr?></a></td>
	<td align="center"><?=$ip_addr?></td>
	<td align="center"><?=$svc_no[0]?></td>
	<td align="center"><a href="javascript:gr_open(<?=$gid[0]?>)"><?=$gid[0]?></a></td>
	<td align="left">&nbsp;<?=$name[0]?></td>
	<td align="center"><?=$arp[$dup_no]["ip"]?></td>
	<td align="center"><?=$svc_no[1]?></td>
	<td align="center"><a href="javascript:gr_open(<?=$gid[1]?>)"><?=$gid[1]?></a></td>
	<td align="left">&nbsp;<?=$name[1]?></td>
  </tr>
<?
		}
		$total_no += $idx;
?>
</table>
</p>
<?
	}
?>

</div>
<?
		echo "<br>&nbsp;&nbsp;<b>Total Retrived Hosts = $total_no</b><br>\n";
	}
?>
<br>
<br>
<br>
</body>
</html>

<?
/////////////// FUNCTION /////////////////

// 중복체크
//
function dup_check ($mac, $no)
{
	global $arp;

	for ($i=0; $i<$no; $i++)
	{
		if ($mac == $arp[$i]["mac"]) return $i;
	}
	return false;
}

//
//	해당 장비의 VAN 에 속한 IP 대역을 FETCH
//
function get_desc ($ip, $db, $comunity)
{
	global $desc_arr, $desc_no, $_POST, $path_snmpwalk;

	$cmd = $path_snmpwalk."-c $comunity $ip ".DESC_OID;
	if (($fp = popen ($cmd, "r")) == false)
	{
		echo __FILE__."(".__LINE__."): execution error. cmd=[$cmd]";
		exit;
	}
//	echo __FILE__."(".__LINE__."): cmd=[$cmd]";

	$no = 0;
	while (!feof ($fp))
	{
		$buffer = fgets ($fp, 256);
		if (strlen($buffer) < 2) break;
//		echo __FILE__."(".__LINE__."): buffer=[$buffer]";
// .1.3.6.1.2.1.2.2.1.2.1 = STRING: Vlan1
		$n = strpos ($buffer, ":");
		$name = substr ($buffer, $n+2);	// first blank skip.
		$name = substr ($name, 0, strlen($name)-1);	// last blank skip.
		if (substr($name,0,4) != "Vlan") continue;
		if ($name == "Vlan1") continue;	// Vlan1 skip
		$n = strpos ($buffer, "=");
		$temp = substr ($buffer, 0, $n-1);	// last blank not copy
		$n = strrpos ($temp, ".");
		$id = substr ($temp, $n+1);	// last blank not copy
		$desc_arr[$ip][$id]["name"] = $name;

		// L3 에 해당하는 VLAN 에 속한 IP 1개를 FETCH (C 클래스에서만 배정되는것을 전제
		$query = "SELECT ip FROM ip_table WHERE L3_ip='$ip' AND vlan='$id' LIMIT 1";
		$tmp_arr = get_array($db, $query);
		$cip = substr ($tmp_arr[0]["ip"], 0, strrpos ($tmp_arr[0]["ip"],'.')+1);

		// 해당 VLAN 의 C 클래스 시작주소와 끝주소를 FETCH
		$query = "SELECT MIN(eip) AS sip, MAX(eip) AS eip FROM ip_table WHERE L3_ip='$ip' AND vlan='$id'";
//	echo __FILE__."(".__LINE__."): query=[$query]<br>\n";
		$tmp_arr = get_array($db, $query);
		$desc_arr[$ip][$id]["sip"] = $cip . $tmp_arr[0]["sip"];
		$desc_arr[$ip][$id]["eip"] = $cip . $tmp_arr[0]["eip"];

		$no++;
	}
	pclose ($fp);
}

//	FETCH L3 명칭 매칭
//
function get_L3_name ($ip)
{
	global $L3_arr;

	for ($i=0; $i<count($L3_arr); $i++)
	{
		if ($ip == $L3_arr[$i]["ip"]) return $L3_arr[$i]["name"];
	}
}

//	GET 커뮤니티
//
function get_comunity ($ip)
{
	global $L3_arr;

	// 커뮤니티 탐색
	for ($i=0; $i<count($L3_arr); $i++)
	{
		if ($ip == $L3_arr[$i]["ip"]) return $L3_arr[$i]["comunity"];
	}
	return false;
}

//	MASK BIT COUNT
//
function count_mask ($mask)
{
	$mask_arr = explode ('.', $mask);
	$count = 0;
	for ($i=0; $i<4; $i++)
	{
		if ($mask_arr[$i] & 0x80) $count++;
		if ($mask_arr[$i] & 0x40) $count++;
		if ($mask_arr[$i] & 0x20) $count++;
		if ($mask_arr[$i] & 0x10) $count++;
		if ($mask_arr[$i] & 0x08) $count++;
		if ($mask_arr[$i] & 0x04) $count++;
		if ($mask_arr[$i] & 0x02) $count++;
		if ($mask_arr[$i] & 0x10) $count++;
	}
	return $count;
}

?>
