<?
//
//	$Id: dmac_list.php,v 1.1.1.1 2008/10/13 06:13:37 winchild Exp $
//
//	NAME: dmac_list.php
//	ARGUMENT:
//	DESCRIPTION:
//		DUPLICATE MAC 중복 LIST.
//
//	REFERENCE:
//		mysql> desc L3host;
//		+----------+-------------+------+-----+---------+-------+
//		| Field    | Type        | Null | Key | Default | Extra |
//		+----------+-------------+------+-----+---------+-------+
//		| ip       | varchar(20) | NO   | PRI |         |       |
//		| name     | varchar(32) | YES  |     | NULL    |       |
//		| host_id  | int(11)     | YES  |     | NULL    |       |
//		| comunity | varchar(16) | YES  |     | NULL    |       |
//		| ts       | datetime    | YES  |     | NULL    |       |
//		+----------+-------------+------+-----+---------+-------+
//		5 rows in set (0.01 sec)
//		
//		mysql> desc dup_mac;
//		+-------+-------------+------+-----+---------+-------+
//		| Field | Type        | Null | Key | Default | Extra |
//		+-------+-------------+------+-----+---------+-------+
//		| mac   | varchar(32) | NO   | PRI |         |       |
//		| l3ip  | varchar(20) | NO   |     |         |       |
//		| ip    | varchar(20) | YES  |     | NULL    |       |
//		| vlan  | varchar(10) | NO   |     |         |       |
//		| memo  | tinytext    | YES  |     | NULL    |       |
//		| ts    | datetime    | YES  |     | NULL    |       |
//		+-------+-------------+------+-----+---------+-------+
//		6 rows in set (0.00 sec)
//
//		mysql> desc sj_mac_ip;
//		+---------+---------------------------+------+-----+---------+----------------+
//		| Field   | Type                      | Null | Key | Default | Extra          |
//		+---------+---------------------------+------+-----+---------+----------------+
//		| sid     | int(11)                   | NO   | PRI | NULL    | auto_increment |
//		| mac     | varchar(32)               | NO   |     |         |                |
//		| ip      | varchar(16)               | NO   |     |         |                |
//		| status  | enum('N','U','E','D','A') | NO   |     |         |                |
//		| idx_sid | int(11)                   | NO   |     |         |                |
//		| L3_ip   | varchar(16)               | NO   |     |         |                |
//		| vlan    | int(11)                   | NO   |     |         |                |
//		+---------+---------------------------+------+-----+---------+----------------+
//		7 rows in set (0.00 sec)
//
//		mysql> desc account;
//		+-----------+---------------+------+-----+---------------------+----------------+
//		| Field     | Type          | Null | Key | Default             | Extra          |
//		+-----------+---------------+------+-----+---------------------+----------------+
//		| sid       | int(11)       | NO   | PRI | NULL                | auto_increment |
//		| gid       | int(11)       | NO   | UNI |                     |                |
//		| ip        | varchar(16)   | NO   | MUL |                     |                |
//		| svc_no    | varchar(6)    | NO   |     |                     |                |
//		| name      | tinytext      | YES  |     | NULL                |                |
//		| wkid      | varchar(6)    | NO   |     |                     |                |
//		| ts        | datetime      | NO   |     | 0000-00-00 00:00:00 |                |
//		| limit_cnt | int(11)       | YES  |     | NULL                |                |
//		| pause     | enum('Y','N') | YES  |     | N                   |                |
//		+-----------+---------------+------+-----+---------------------+----------------+
//		9 rows in set (0.00 sec)
//

	require_once("./config.php");
	require_once("../include/config.php");
	require_once("DIRECTLIB/adodb/adodb.inc.php");
	require_once("DIRECTLIB/include/db.php");

	$db = db_conn ($database_type, $database_hostname, $database_username, $database_password, $database_default);
	if ($db === false)
	{
		die ("connect faild");
	}

	$ts = time() - (3600 * 24 * 3);	// 3일전 TIMESTAMP
	$bf3_date = date ("Y-m-d H:i:s", $ts);

	$query = "SELECT sid FROM sj_mac_ip_idx WHERE ts='$bf3_date'";
	$bf3_idx = "";
	if (($dmac_arr = get_array($db, $query)) !== false) $bf3_idx = $dmac_arr[0]["sid"];

?>
<html>
<head>
<title>MAC DUPLICATE List - Samjung Data Service Network Admin</title>
<link rel="stylesheet" type="text/css" href="style.css" />
<!--script type="text/javascript" src="./utils_lib.js"></script>
<script type="text/javascript" src="./ajax_lib.js"></script>
<script type="text/javascript" src="./xml_lib.js"></script-->
<script language="javascript">
<!--

-->
</script>
</head>
<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<? require_once ("cacti_head.php") ?>
<br>
<div align="left" style="margin-left:10px;">
| <a href="dup_list.php">PREV</a> |
<table width="90%" border=0>
 <tr>
  <td align="left">
    <font size="3"><b>MAC LIST</b></font>
  </td>
 </tr>
</table>
</table>
<?
	// 중복된 MAC 목록.
	$query = "SELECT a.mac,a.ip,a.status,b.ts FROM sj_mac_ip a, sj_mac_ip_idx b WHERE a.mac='".$_GET["mac"]."' AND a.idx_sid=b.sid".($bf3_idx?" AND a.idx_sid>'$bf3_idx'":"");
//echo __FILE__."(".__LINE__."): query=[$query]";
	if (($dmac_arr = get_array($db, $query)) === false) $dmac_arr = array ();
?>
<table width="98%" border="0" bgcolor="#EFEFEF">
  <tr bgcolor="#3154a5" height="24" align="center">
    <td width="32"><font color="white">NO</font></td>
    <td width="150"><font color="white">MAC</font></td>
    <td width="100"><font color="white">IP</font></td>
    <td width="100"><font color="white">STATUS</font></td>
    <td width="*"><font color="white">DATE</font></td>
  </tr>
<?
	for ($i=0; $i<count($dmac_arr); $i++)
	{
?>
  <tr bgcolor="white" align="center">
	<td><?=($i+1)?></td>
	<td><?=$dmac_arr[$i]["mac"]?></td>
	<td><?=$dmac_arr[$i]["ip"]?></td>
	<td>&nbsp;<?=$status_msg[$dmac_arr[$i]["status"]]?></td>
	<td align="left">&nbsp;<?=$dmac_arr[$i]["ts"]?></td>
  </tr>
<?
	}
?>
</table>
</p>

</div>
</body>
</html>

<?
/////////////// FUNCTION /////////////////

?>
