<?
//
//	$Id: gls.php,v 1.1.1.1 2008/10/13 06:13:37 winchild Exp $
//
//	NAME:
//	ARGUMENT:
//	DESCRIPTION:
//		관리자용의 페이지를 보여준다. 상단의 TAB 별로 구분하며, TAB 별로 그래프를 구성한다.
//
//		일반적으로 gls 에 설정하는 그래픽아이디를 키로 구분하는데, 합산그래프 일경우에는
//		그래픽아이디가 0 이다. 이것을 키이로, 제한용량을 저장하고, 그래픽아이디가 0 인경우에는
//		합산된 용량으로 제한용량과 ScanTraff.c 에서 비교하여 DB 에 수록하고, 여기에서 보여준다.
//
//	REFERENCE:
//
//		mysql> desc tab
//		+------------+---------------+------+-----+---------------------+----------------+
//		| Field      | Type          | Null | Key | Default             | Extra          |
//		+------------+---------------+------+-----+---------------------+----------------+
//		| sid        | int(11)       | NO   | PRI | NULL                | auto_increment |
//		| name       | tinytext      | YES  |     | NULL                |                |
//		| gsum       | enum('Y','N') | YES  |     | N                   |                |
//		| ov_alarm   | enum('Y','N') | YES  |     | N                   |                |
//		| sms_alarm  | enum('Y','N') | YES  |     | N                   |                |
//		| col        | int(11)       | NO   |     | 2                   |                |
//		| dur        | int(11)       | NO   |     | 24                  |                |
//		| wkid       | varchar(6)    | NO   |     |                     |                |
//		| ts         | datetime      | NO   |     | 0000-00-00 00:00:00 |                |
//		| ov_total   | int(11)       | YES  |     | NULL                |                |
//		| unit       | varchar(4)    | YES  |     |                     |                |
//		| work_mask  | tinyint(4)    | YES  |     | 0                   |                |
//		+------------+---------------+------+-----+---------------------+----------------+
//		
//		mysql> desc gls;
//		+----------+------------+------+-----+---------------------+----------------+
//		| Field    | Type       | Null | Key | Default             | Extra          |
//		+----------+------------+------+-----+---------------------+----------------+
//		| sid      | int(11)    | NO   | PRI | NULL                | auto_increment |
//		| tab_sid  | int(11)    | YES  |     | NULL                |                |
//		| gid      | int(11)    | NO   | UNI |                     |                |
//		| ov_limit | int(11)    | YES  |     | NULL                |                |
//		| wkid     | varchar(6) | NO   |     |                     |                |
//		| ts       | datetime   | NO   |     | 0000-00-00 00:00:00 |                |
//		+----------+------------+------+-----+---------------------+----------------+
//		
//		mysql> desc sj_memo;
//		+---------+------------+------+-----+---------------------+----------------+
//		| Field   | Type       | Null | Key | Default             | Extra          |
//		+---------+------------+------+-----+---------------------+----------------+
//		| sid     | int(11)    | NO   | PRI | NULL                | auto_increment |
//		| tab_sid | int(11)    | YES  |     | NULL                |                |
//		| memo    | tinytext   | NO   |     |                     |                |
//		| wkid    | varchar(6) | NO   |     |                     |                |
//		| ts      | datetime   | NO   |     | 0000-00-00 00:00:00 |                |
//		+---------+------------+------+-----+---------------------+----------------+
//

	require_once("../include/config.php");
	require_once("DIRECTLIB/adodb/adodb.inc.php");
	require_once("DIRECTLIB/include/db.php");

	$db = db_conn ($database_type, $database_hostname,
		$database_username, $database_password, $database_default);
	if ($db === false)
	{
		die ("connect faild");
	}

	// 탭을 추가하는 폼은 분리되어 있지만, 메모와 제한용량을 추가하는 폼은 겹쳐져 있다.
	if (isset($_POST["submit"]))
	{
		// Limit 저장
		if ($_POST["submit"] == "Limit Update")
		{
			foreach ($_POST as $aKey => $aValue)
			{
				if (substr($aKey,0,4) == "GID_")
				{
					$gid = substr($aKey,4);
					if ($gid == 0)	// 0 는 합산으로 이전에 입력된 적이 없을수 있다.
					{
						$query = "REPLACE INTO gls (gid,tab_sid,ov_limit,ts)
							VALUES ('0','".$_GET["tab"]."','$aValue',NOW())";
					}
					else $query = "UPDATE gls SET ov_limit='$aValue' WHERE gid='$gid'";
					if ($db->Execute ($query) === false) die ("SQL=[$query] : Error");
				}
            }
		}
		else if ($_POST["submit"] == "Add Tab")
		{
			// 탭추가
			$query = "INSERT INTO tab (name,ts) VALUES ('".$_POST["tab"]."',NOW())";
			if ($db->Execute ($query) === false) die ("SQL=[$query] : Error");
			$tab_id = $db->Insert_ID();
		}
		else if ($_POST["submit"] == "Add Memo")
		{
			// 메모추가
			$query = "INSERT INTO sj_memo (tab_sid,memo,ts)
				VALUES ('".$_GET["tab"]."','".$_POST["memo"]."',NOW())";
			if ($db->Execute ($query) === false) die ("SQL=[$query] : Error");
		}
		else if ($_POST["submit"] == "Save")
		{
			// 탭의 상세 설정내용 추가.
			if (isset($_POST["gsum"])) $gsum = "Y";
			else $gsum = "N";

			if (isset($_POST["sms_alarm"])) $vsms_alarm = "Y";
			else $vsms_alarm = "N";
			if (isset($_POST["ov_alarm"])) $vov_alarm = "Y";
			else $vov_alarm = "N";


			$work_mask = 0;
			if (isset($_POST["mask_net"])) $work_mask |= ($_POST["mask_net"] == 'Y' ? 1 : 0);
			if (isset($_POST["mask_mail"])) $work_mask |= ($_POST["mask_mail"] == 'Y' ? 2 : 0);
			if (isset($_POST["mask_lnx"])) $work_mask |= ($_POST["mask_lnx"] == 'Y' ? 4 : 0);
			if (isset($_POST["mask_win"])) $work_mask |= ($_POST["mask_win"] == 'Y' ? 8 : 0);

			$query = "UPDATE tab SET
				col='".$_POST["col"]."', dur='".$_POST["dur"]."',
				gsum='$gsum',sms_alarm='$vsms_alarm', ov_alarm='$vov_alarm',
				unit='".$_POST["unit"]."',
				work_mask='$work_mask',
				ts=NOW() WHERE sid='".$_GET["tab"]."'";
//echo __LINE__.": SQL=[$query]";
			if ($db->Execute ($query) === false) die ("SQL=[$query] : Error");
			$tab_id = $db->Insert_ID();
		}
		else if ($_POST["submit"] == "Tab Delete")
		{
			// 탭삭제
			$query = "DELETE FROM tab WHERE sid='".$_GET["tab"]."'";
			if ($db->Execute ($query) === false) die ("SQL=[$query] : Error");
			unset ($_GET["tab"]);
		}
		else	die ("Graph Add or Tab Add argument missing!");
	}

	if (isset($_GET["act"]))
	{
		if ($_GET["act"] == "del")
		{
			// 그래프 삭제
			$query = "DELETE FROM gls WHERE gid='".$_GET["gid"]."'";
			if ($db->Execute ($query) === false) die ("SQL=[$query] : Error");
		}
		else	die ("Not suport argument!");
	}

	if (isset ($_GET["tab"])) $tab_id = $_GET["tab"];

	$ct = date ("Y-m-d H:i:s", time()-1800);	// 마지막 30분전의 데이터만 FETCH
?>
<html>
<head>
<title>Samjung Data Serveice Network Traffic Graph</title>
<link rel="stylesheet" type="text/css" href="style.css" />
<meta http-equiv=refresh content='300'>
<script language="javascript">
<!--
function tab_val ()
{
	if (document.tab_form.tab.value.length == 0)
	{
		alert ("Tab name empty!");
		document.tab_form.tab.focus();
		return false;
	}
	return true;

}

-->
</script>
</head>
<body leftmargin="0" topmargin="10" marginwidth="0" marginheight="0">
<? require_once ("cacti_head.php") ?>
&nbsp;<font size="3"><b>MONITORING PAGE.</b></font><br><br>
<form name="tab_form" method="post" action="gls.php" OnSubmit="return tab_val()">
&nbsp;
<?
	// 탭 읽기
	$query = "SELECT sid,name,gsum,col,dur,ov_alarm,sms_alarm,unit,work_mask FROM tab ORDER BY name";
	$ret = get_array($db, $query);

	for ($i=0; $i<count($ret); $i++)
	{
		echo "[<a href=\"gls.php?tab=".$ret[$i]["sid"]."\">";
		if (isset($tab_id) && $ret[$i]["sid"] == $tab_id)
		{
			$vcol = $ret[$i]["col"];
			$vdur = $ret[$i]["dur"];
			$vname = $ret[$i]["name"];
			$vgsum = $ret[$i]["gsum"];				// 합산그래프 여부
			$vsms_alarm = $ret[$i]["sms_alarm"];	// SMS 알림체크
			$vov_check = $ret[$i]["ov_alarm"];		// 오버트래픽 체크
			$vunit = $ret[$i]["unit"];				// 단위
			echo "<b>".$ret[$i]["name"]."</b>";
			$vnet = ($ret[$i]["work_mask"] & 1) ? "Y": "N";
			$vmail = ($ret[$i]["work_mask"] & 2) ? "Y": "N";
			$vlnx = ($ret[$i]["work_mask"] & 4) ? "Y": "N";
			$vwin = ($ret[$i]["work_mask"] & 8) ? "Y": "N";
		}
		else echo $ret[$i]["name"];
		echo "</a>]\n";
	}
?>
<input type="text" name="tab" size="16" maxlength="16">
<input type="submit" name="submit" value="Add Tab">
</form>
<hr>
<?
	if (isset($tab_id) && isset($_GET["tab"]))
	{
		// a-z 까지 니모닉을 사용하므로 26개 이상은 사용불가.
		$query = "SELECT count(*) AS count from gls WHERE tab_sid='".$_GET["tab"]."' AND gid<>0";
		$ret = get_array($db, $query);
		$graph_count = $ret[0]["count"];
		$sum_disable = "";
		if ($graph_count > 26)
		{
			if ($vgsum != 'Y') $sum_disable = "disabled";
		}
?>
<div align="left" style="margin-left:10px;">
<form name="gls_form" method="post" action="gls.php?tab=<?=$tab_id?>">
<strong><font size="3"><?=$vname?></font></strong>:
COL: <input type="text" name="col" value="<?=$vcol?>" size="2" maxlength="2"> /
DUR.(HR) : <input type="text" name="dur" value="<?=$vdur?>" size="2" maxlength="2"> /
UNIT : <input type="text" name="unit" value="<?=$vunit?>" size="4" maxlength="4"> /
Total: <input type="checkbox" name="gsum" value="Y" <?=($vgsum=='Y'?"checked":"")?> <?=$sum_disable?>> <br/>
EXCEED Check: <input type="checkbox" name="ov_alarm" value="Y" <?=($vov_check=='Y'?"checked":"")?>> /
SMS Alarm: <input type="checkbox" name="sms_alarm" value="Y" <?=($vsms_alarm=='Y'?"checked":"")?>> /
(<input type="checkbox" name="mask_net" value="Y" <?=($vnet=='Y'?"checked":"")?>> NET,
<input type="checkbox" name="mask_mail" value="Y" <?=($vmail=='Y'?"checked":"")?>> MAIL,
<input type="checkbox" name="mask_lnx" value="Y" <?=($vlnx=='Y'?"checked":"")?>> LNX WEB,
<input type="checkbox" name="mask_win" value="Y" <?=($vwin=='Y'?"checked":"")?>> WIN WEB)
<input type="submit" name="submit" value="Save">
<input type="submit" name="submit" value="Tab Delete" OnClick="return confirm('Graph Table & Tab delete?',0)">
</form>
<hr>
<form name="graph_form" method="post" action="gls.php?tab=<?=$tab_id?>">
<table>
  <tr>
    <td>
<?
	// 해당탭에 속한 그래프 정보 FETCH
	$query = "SELECT b.gid,a.ip,a.svc_no,a.name,a.limit_cnt,b.ov_limit
		FROM gls b LEFT JOIN account a ON a.gid=b.gid WHERE b.tab_sid='$tab_id'";
	if (($ret = get_array($db, $query)) !== false)
	{
		// 시작, 종료시간
		$et=time(); $st=$et-(3600*$vdur);

		// 그래프 크기
		$width = 500;
		$height = 180;

		$gheight = 100;
		$gwidth = 300;

		// 합산그래프 GID 모음
		$total_gids = "";
		$gid_0 = -1;
		for ($i=0; $i<count($ret); $i++)
		{
			if ($ret[$i]["gid"] == 0) $gid_0 = $i;	// gid 0 는 따로 처리.
			else
			{
				if ($vgsum == 'Y') $total_gids .= $ret[$i]["gid"] . ",";
			}
		}
		$total_gids = substr ($total_gids, 0, -1);

		if ($vgsum == "Y")
		{
?>
<b>TOTAL</b>
<?
			if ($vov_check == "Y")	// 오버트래픽 체크에서만 나타나야 한다.
			{
?>
Limit : <input type="text" name="GID_0"
	value="<?=($gid_0>=0?$ret[$gid_0]["ov_limit"]:"")?>" size="4" maxlength="4" value=""> <?=$vunit?> 
<?
			}

			// 여기에 해당그래픽을 삭제하는 [X] 는 필요없다. 탭옵션에서 Total Graph 을 체크아웃하면 된다.
			if ($gid_0 >= 0)
			{
				// 오버 트래픽 체크, gid 가 0 에서 ScanTraff 에서
				// 합산트래픽의 오버여부를 기록해서 투입한다.
				$query = "SELECT IF (a.ov_in>a.ov_out,a.ov_in,a.ov_out) AS over_cnt
					FROM ov_trff a, ov_trff_pri b
					WHERE a.gid='0' AND b.sid=a.pid AND b.ts>'$ct' ORDER BY pid DESC LIMIT 1";
				$ov_trff = get_array($db, $query);
				if ($ov_trff[0]["over_cnt"]>$ret[$gid_0]["ov_limit"])
					echo "<font color=red><b>".$ov_trff[0]["over_cnt"]." $vunit<b></font>";
			}
?>
	<br>
	<a href="totalpage.php?gid=<?=$total_gids?>"><img
	src="totalgraph.php?gid=<?=$total_gids?>&pt=<?=$vdur?>" border=0 width=481 height=193></a>
<?
		}
?>
   </td>
   <td height="100">
<?
	// 메모 목록 FETCH
	$query = "SELECT memo,DATE_FORMAT(ts,'%m-%d %H:%i') AS ts
		FROM sj_memo WHERE tab_sid='$tab_id' ORDER BY ts DESC LIMIT 10";
	$memo_arr = get_array($db, $query);
?>
    <ul>
<?
	// 메모 목록 추가
	for ($i=0; $i<count($memo_arr); $i++)
	{
		if ($i == $gid_0) continue; // gid 0 는 total 이므로 SKIP
?>
      <li><?=$memo_arr[$i]["ts"]?> - <?=$memo_arr[$i]["memo"]?></li>
<?
	}
?>
<br>
MEMO: <input type="text" name="memo" value="" size="40" maxlength="200">
<input type="submit" name="submit" value="Add Memo">
   </td>
  <tr>
</table>
<br>
<table>
  <tr>
<?
	// gid 로 설정한 그래픽 출력
	for ($i=0, $j=1; $i<count($ret); $i++)
	{
		if ($ret[$i]["gid"] == 0) continue;	// gid 0 는 합산하는 가상의 gid 이다.
		if ((($j) % $vcol)) echo "<tr>\n";

?>
	<td width="<?=$width?>" height="<?=$height?>" bgcolor="white">
		<font size="2">
		<b>GID:<?=$ret[$i]["gid"]?></b>
<?
				if ($ret[$i]["name"] != "") echo $ret[$i]["name"]."(".$ret[$i]["svc_no"].") - ".$ret[$i]["ip"]." / ".$ret[$i]["limit_cnt"].$vunit;
?>
		</font>
<?
		$query = "SELECT a.hostname,a.description FROM host a, graph_local b WHERE a.id=b.host_id AND b.id='".$ret[$i]["gid"]."'";
		if (($host_arr = get_array($db, $query)) !== false)
		{
			// 서버정보 출력
?>
		<font size="2"><?=$host_arr[0]["description"]?> (<?=$host_arr[0]["hostname"]?>)</font>
<?
		}

		if ($vov_check == "Y")
		{
			// 오버트래픽 체크일경우에 제한용량을 입력하는 object 를 활성화.
?>
		Limit: <input type="text" size="4" name="GID_<?=$ret[$i]["gid"]?>" value="<?=$ret[$i]["ov_limit"]?>" maxlength="4"> <?=$vunit?>
<?		}	?>
 [<a href="gls.php?gid=<?=$ret[$i]["gid"]?>&tab=<?=$tab_id?>&act=del">X</a>]
<?
		$query = "SELECT IF (a.ov_in>a.ov_out,a.ov_in,a.ov_out) AS over_cnt FROM ov_trff a, ov_trff_pri b
			WHERE a.gid='".$ret[$i]["gid"]."' AND b.sid=a.pid AND b.ts>'$ct' ORDER BY pid DESC LIMIT 1";
		$ov_trff = get_array($db, $query);
		if ($ov_trff[0]["over_cnt"]>$ret[$i]["ov_limit"]) echo "<font color=red><b>".$ov_trff[0]["over_cnt"]." $vunit<b></font>";

?>
<br>
<a href="/graph.php?local_graph_id=<?=$ret[$i]["gid"]?>&rra_id=all">
<img src="../graph_image.php?local_graph_id=<?=$ret[$i]["gid"]?>&rra_id=0&graph_height=<?=$gheight?>&graph_width=<?=$gwidth?>&graph_nolegend=true&graph_start=<?=$st?>&graph_end=<?=$et?>"></a><br>
	</td>
<?
				if (!($j % $vcol)) echo "</tr>\n";
				$j++;
			}
			if (!($j % $vcol)) echo "<td bgcolor=\"white\">&nbsp;</td></tr>\n";
?>
</table>
<?		}
		if ($vov_check == "Y")
		{
			// 오버트래픽 체크일경우에 제한용량을 입력하는 submit 를 활성화.
?>
<input type="submit" name="submit" value="Limit Update">
</form>
<?
		}
	}
	close_db ($db);
?>
</div>
</body>
</html>
