<?php

class Board {

	var $id;
	var $name;
	var $use_upload;
	var $upload_count;
	var $use_link;
	var $link_count;
	var $use_reply;
	var $use_comment;
	var $use_category;
	var $member_priv;
	var $nobody_priv;
	var $header;
	var $tail;

	var $category;
	var $comment;

	var $db;
	var $tablename;

	function Board($db, $id) {

		$this->db = $db;
		$this->id = trim($id);
		$this->tablename = "t_board_" . $this->id;

		$query = "SELECT * FROM t_board_config WHERE id = " . $this->id;
		if(!$db->query($query)) {
			$db->close();
			goback("게시판 정보를 조회하는 도중 오류가 발생하였습니다.");
		}

		if($db->nf() <= 0) {
			$db->close();
			goback("이미 삭제되었거나 없는 게시판입니다.");
		}

		$db->next_record();

		$this->name = $db->f("name");
		$this->use_upload = $db->f("use_upload");
		$this->upload_count = $db->f("upload_count");
		$this->use_link = $db->f("use_link");
		$this->link_count = $db->f("link_count");
		$this->use_reply = $db->f("use_reply");
		$this->use_comment = $db->f("use_comment");
		$this->use_category = $db->f("use_category");
		$this->member_priv = $db->f("member_priv");
		$this->nobody_priv = $db->f("nobody_priv");
		$this->header = stripslashes(trim($db->f("header")));
		$this->tail = stripslashes(trim($db->f("tail")));

		if($this->use_category == "T") {
			$query = "SELECT * FROM t_board_" . $this->id . "_category ORDER BY no";
			if(!$db->query($query)) {
				$db->close();
				goback("게시판 카테고리 정보를 조회하는 도중 오류가 발생하였습니다.");
			}

			$this->category = array();

			if($db->nf() > 0) {
				while($db->next_record()) {
					$this->category[count($this->category)] = array("no" => $db->f("no"), "name" => $db->f("name"));
				}
			}
		}
	}

	//////////////////////////////////////////
	// 검색 조건문 작성
	//////////////////////////////////////////
	function make_condition() {

		global $sn, $ss, $sc, $keyword, $cg;

		$condition = "";
		if(isset($keyword) && $keyword != "") {
			$keyword = urldecode(trim($keyword));

			if(isset($sn) && $sn == "on") {
				$condition .= " (" . $this->tablename . ".writer like '%" . $keyword . "%' OR t_member.guest_name like '%" . $keyword . "%')";
			}

			if(isset($ss) && $ss == "on") {
				if($condition != "") {
					$condition .= " OR";
				}
				$condition .= " " . $this->tablename . ".subject like '%" . $keyword . "%'";
			}

			if(isset($sc) && $sc == "on") {
				if($condition != "") {
					$condition .= " OR";
				}
				$condition .= " " . $this->tablename . ".content like '%" . $keyword . "%'";
			}
		}

		if(isset($cg) && $cg != "") {
			if($condition != "") {
				$condition .= "(" . $condition . ") AND " . $this->tablename . "_category.no = " . $cg;
			} else {
				$condition .= $this->tablename . "_category.no = " . $cg;
			}
		}

		return $condition;
	}

	////////////////////////////////////////
	// 게시글 총 개수 조회
	////////////////////////////////////////
	function get_total_count() {
		
		$condition = $this->make_condition();

		$query = "
			SELECT count(*) as total
			FROM " . $this->tablename . "
				LEFT OUTER JOIN t_member ON " . $this->tablename . ".guest_no = t_member.guest_no
				LEFT OUTER JOIN " . $this->tablename . "_category ON " . $this->tablename . ".category = " . $this->tablename . "_category.no 
			" . ($condition != "" ? "WHERE " . $condition : "");
	
		if(!$this->db->query($query)) {
			$this->db->close();
			goback("게시물 개수를 계산하는 도중 오류가 발생하였습니다.");
		}
		$this->db->next_record();

		return $this->db->f("total");
	}

	////////////////////////////////////////
	// 이전글 조회
	////////////////////////////////////////
	function get_prev_article($no, $gid, $pos) {
		
		$prev_article = array("no" => "", "subject" => "");

		$condition = $this->make_condition();

		$query = "
			SELECT
				no,subject
			FROM " . $this->tablename . " LEFT OUTER JOIN t_member ON " . $this->tablename . ".guest_no = t_member.guest_no
			WHERE " . ($condition != "" ? " (" . $condition . ") AND " : "") . "
				( (" . $this->tablename . ".gid = " . $gid . " AND " . $this->tablename . ".pos < " . $pos . ") OR
				  (" . $this->tablename . ".gid > " . $gid . ") ) AND is_del = '0' AND is_notice = '0'
			ORDER BY " . $this->tablename . ".gid ASC, " . $this->tablename . ".pos LIMIT 1 offset 0";

		if($this->db->query($query)) {
			$this->db->next_record();
			
			$prev_article["no"] = $this->db->f("no");
			$prev_article["subject"] = $this->db->f("subject");
		}

		return $prev_article;
	}

	////////////////////////////////////////
	// 다음글 조회
	////////////////////////////////////////
	function get_next_article($no, $gid, $pos) {

		$next_article = array("no" => "", "subject" => "");

		$condition = $this->make_condition();

		$query = "
			SELECT
				no,subject
			FROM " . $this->tablename . " LEFT OUTER JOIN t_member ON " . $this->tablename . ".guest_no = t_member.guest_no
			WHERE " . ($condition != "" ? " (" . $condition . ") AND " : "") . "
				( (" . $this->tablename . ".gid = " . $gid . " AND " . $this->tablename . ".pos > " . $pos . ") OR
				  (" . $this->tablename . ".gid < " . $gid . ") ) AND is_del = '0' AND is_notice = '0'
			ORDER BY " . $this->tablename . ".gid DESC, " . $this->tablename . ".pos ASC LIMIT 1 offset 0";

		if($this->db->query($query)) {
			$this->db->next_record();

			$next_article["no"] = $this->db->f("no");
			$next_article["subject"] = $this->db->f("subject");
		}

		return $next_article;
	}

	////////////////////////////////////////
	// 새글등록
	////////////////////////////////////////
	function write($auth, $postdata, $attachfiles) {

		$use_html = ($postdata["use_html"] == "on" ? "1" : "0");
		$alert_reply = ($postdata["alert_reply"] == "on" ? "1" : "0");
		$is_secret = ($postdata["is_secret"] == "on" ? "1" : "0");
		$is_notice = ($postdata["is_notice"] == "on" ? "1" : "0");
		$subject = trim($postdata["subject"]);
		$content = trim($postdata["content"]);
		$homepage = trim($postdata["homepage"]);
		$sitelink1 = trim($postdata["sitelink1"]);
		$sitelink2 = trim($postdata["sitelink2"]);
		$category = trim($postdata["category"]);

		$fileinfo = $this->file_upload($attachfiles);

		$query = "
			INSERT INTO " . $this->tablename . "
				(no,guest_no,ip,subject,content,use_html,category,homepage,
				 sitelink1,sitelink2,alert_reply,is_secret,is_notice,wdate,
				 gid,fid1,fname1,ftype1,fsize1,fid2,fname2,ftype2,fsize2)
			SELECT
				IFNULL(MAX(no),0)+1,
				'" . $auth->guest_no . "',
				'" . getenv('REMOTE_ADDR') . "',
				'" . addslashes($subject) . "',
				'" . addslashes($content) . "',
				'" . $use_html . "',
				" . ($category == "" ? "NULL" : $category) . ",
				'" . addslashes($homepage) . "',
				'" . addslashes($sitelink1) . "',
				'" . addslashes($sitelink2) . "',
				'" . $alert_reply . "',
				'" . $is_secret . "',
				'" . $is_notice . "',
				UNIX_TIMESTAMP(),
				IFNULL(MAX(no),0)+1,
				" . ($fileinfo[0] == null ? "NULL" : "'" . trim($fileinfo[0]["fid"]) . "'") . ",
				" . ($fileinfo[0] == null ? "NULL" : "'" . addslashes(trim($fileinfo[0]["fname"])) . "'") . ",
				" . ($fileinfo[0] == null ? "NULL" : "'" . addslashes(trim($fileinfo[0]["ftype"])) . "'") . ",
				" . ($fileinfo[0] == null ? "0" : trim($fileinfo[0]["fsize"])) . ",
				" . ($fileinfo[1] == null ? "NULL" : "'" . trim($fileinfo[1]["fid"]) . "'") . ",
				" . ($fileinfo[1] == null ? "NULL" : "'" . addslashes(trim($fileinfo[1]["fname"])) . "'") . ",
				" . ($fileinfo[1] == null ? "NULL" : "'" . addslashes(trim($fileinfo[1]["ftype"])) . "'") . ",
				" . ($fileinfo[1] == null ? "0" : trim($fileinfo[1]["fsize"])) . "
			FROM " . $this->tablename;
		
		if(!$this->db->query($query)) {
			$this->db->close();
			goback("게시글을 등록하는 도중 오류가 발생하였습니다.");
		}

		$this->db->close();
	}

	////////////////////////////////////////
	// 글수정
	////////////////////////////////////////
	function modify($postdata, $attachfiles) {

		$no = trim($postdata["no"]);
		$use_html = ($postdata["use_html"] == "on" ? "1" : "0");
		$alert_reply = ($postdata["alert_reply"] == "on" ? "1" : "0");
		$is_secret = ($postdata["is_secret"] == "on" ? "1" : "0");
		$is_notice = ($postdata["is_notice"] == "on" ? "1" : "0");
		$subject = trim($postdata["subject"]);
		$content = trim($postdata["content"]);
		$homepage = trim($postdata["homepage"]);
		$sitelink1 = trim($postdata["sitelink1"]);
		$sitelink2 = trim($postdata["sitelink2"]);
		$category = trim($postdata["category"]);

		$query = "SELECT fid1,fid2 FROM " . $this->tablename . " WHERE no = " . $no;
		if($this->db->query($query)) {
			if($this->db->nf() > 0) {
				$this->db->next_record();

				$old_fid1 = $this->db->f("fid1");
				$old_fid2 = $this->db->f("fid2");
			}
		}

		$fileinfo = $this->file_upload($attachfiles);

		$query = "
			UPDATE " . $this->tablename . "
				SET
					subject = '" . addslashes($subject) . "',
					content = '" . addslashes($content) . "',
					use_html = '" . $use_html . "',
					category = " . ($category == "" ? "NULL" : $category) . ",
					homepage = '" . addslashes($homepage) . "',
					sitelink1 = '" . addslashes($sitelink1) . "',
					sitelink2 = '" . addslashes($sitelink2) . "',
					alert_reply = '" . $alert_reply . "',
					is_secret = '" . $is_secret . "',
					is_notice = '" . $is_notice . "'";
		
		if($fileinfo[0] != null) {
			$query .= ",
					fid1 = '" . trim($fileinfo[0]["fid"]) . "',
					fname1 = '" . addslashes(trim($fileinfo[0]["fname"])) . "',
					ftype1 = '" . addslashes(trim($fileinfo[0]["ftype"])) . "',
					fsize1 = " . trim($fileinfo[0]["fsize"]);
		}
		if($fileinfo[1] != null) {
			$query .= ",
					fid2 = '" . trim($fileinfo[1]["fid"]) . "',
					fname2 = '" . addslashes(trim($fileinfo[1]["fname"])) . "',
					ftype2 = '" . addslashes(trim($fileinfo[1]["ftype"])) . "',
					fsize2 = " . trim($fileinfo[1]["fsize"]);
		}

		$query .= "	WHERE no = " . $no;
		
		if(!$this->db->query($query)) {
			$this->db->close();
			print $query; exit;
			goback("게시글을 수정하는 도중 오류가 발생하였습니다.");
		}

		$this->db->close();

		// 기존 업로드 파일 삭제
		if($fileinfo[0] != null && isset($old_fid1) && $old_fid1 != "") {
			$this->delete_file($old_fid1);
		}
		if($fileinfo[1] != null && isset($old_fid2) && $old_fid2 != "") {
			$this->delete_file($old_fid2);
		}
	}

	////////////////////////////////////////
	// 답변쓰기
	////////////////////////////////////////
	function reply($auth, $postdata, $attachfiles) {

		$parent = trim($postdata["parent"]);
		$use_html = ($postdata["use_html"] == "on" ? "1" : "0");
		$alert_reply = ($postdata["alert_reply"] == "on" ? "1" : "0");
		$is_secret = ($postdata["is_secret"] == "on" ? "1" : "0");
		$is_notice = ($postdata["is_notice"] == "on" ? "1" : "0");
		$subject = trim($postdata["subject"]);
		$content = trim($postdata["content"]);
		$homepage = trim($postdata["homepage"]);
		$sitelink1 = trim($postdata["sitelink1"]);
		$sitelink2 = trim($postdata["sitelink2"]);
		$category = trim($postdata["category"]);

		$fileinfo = $this->file_upload($attachfiles);

		// 원문의 배치 정보를 조회
		$query = "
			SELECT
				gid,pos,depth
			FROM " . $this->tablename . "
			WHERE no = " . $parent;
		
		if(!$this->db->query($query)) {
			$this->db->close();
			goback("원문 정보를 조회하는 도중 오류가 발생하였습니다.");
		}
		$this->db->next_record();

		$gid = $this->db->f("gid");
		$pos = $this->db->f("pos") + 1;
		$depth = $this->db->f("depth") + 1;

		// 배치 정보 수정
		$query = "
			UPDATE " . $this->tablename . "
				SET pos = pos + 1
			WHERE gid = " . $gid . " AND pos >= " . $pos;

		if(!$this->db->query($query)) {
			$this->db->close();
			goback("답글을 등록하기 위한 준비 도중 오류가 발생하였습니다.");
		}

		// 답글 등록
		$query = "
			INSERT INTO " . $this->tablename . "
				(no,guest_no,ip,subject,content,use_html,category,homepage,
				 sitelink1,sitelink2,alert_reply,is_secret,is_notice,wdate,gid,pos,depth,parent,
				 fid1,fname1,ftype1,fsize1,fid2,fname2,ftype2,fsize2)
			SELECT
				IFNULL(MAX(no),0)+1,
				'" . $auth->guest_no . "',
				'" . getenv('REMOTE_ADDR') . "',
				'" . addslashes($subject) . "',
				'" . addslashes($content) . "',
				'" . $use_html . "',
				" . ($category == "" ? "NULL" : $category) . ",
				'" . addslashes($homepage) . "',
				'" . addslashes($sitelink1) . "',
				'" . addslashes($sitelink2) . "',
				'" . $alert_reply . "',
				'" . $is_secret . "',
				'" . $is_notice . "',
				UNIX_TIMESTAMP(),
				" . $gid . ",
				" . $pos . ",
				" . $depth . ",
				" . $parent . ",
				" . ($fileinfo[0] == null ? "NULL" : "'" . trim($fileinfo[0]["fid"]) . "'") . ",
				" . ($fileinfo[0] == null ? "NULL" : "'" . addslashes(trim($fileinfo[0]["fname"])) . "'") . ",
				" . ($fileinfo[0] == null ? "NULL" : "'" . addslashes(trim($fileinfo[0]["ftype"])) . "'") . ",
				" . ($fileinfo[0] == null ? "0" : trim($fileinfo[0]["fsize"])) . ",
				" . ($fileinfo[1] == null ? "NULL" : "'" . trim($fileinfo[1]["fid"]) . "'") . ",
				" . ($fileinfo[1] == null ? "NULL" : "'" . addslashes(trim($fileinfo[1]["fname"])) . "'") . ",
				" . ($fileinfo[1] == null ? "NULL" : "'" . addslashes(trim($fileinfo[1]["ftype"])) . "'") . ",
				" . ($fileinfo[1] == null ? "0" : trim($fileinfo[1]["fsize"])) . "
			FROM " . $this->tablename;
		
		if(!$this->db->query($query)) {
			$this->db->close();
			goback("답글을 등록하는 도중 오류가 발생하였습니다.");
		}

		$this->db->close();

		if(isset($postdata["replymail"]) && $postdata["replymail"] != "") {
			sendmail($postdata["replymail"], $subject, nl2br($content));
		}
	}

	////////////////////////////////////////
	// 파일 업로드
	////////////////////////////////////////
	function file_upload($attachfiles) {

		// 업로드 경로
		//$UPLOAD_PATH = UPLOAD_BASE_PATH . "board" . $this->id . "/";
		$UPLOAD_PATH = "./data/board" . $this->id . "/";

		if(!@file_exists($UPLOAD_PATH)) {
			@exec("mkdir -p " . $UPLOAD_PATH);
		}

		$result[0] = null;
		$result[1] = null;

		if(isset($attachfiles["attach_file1"]) && $attachfiles["attach_file1"]["name"] != "" && $attachfiles["attach_file1"]["size"] > 0) {
			// 파일의 유일키 생성
			$fid = md5("board" . $this->id . $attachfiles["attach_file1"]["name"] . time());
			
			@move_uploaded_file($attachfiles["attach_file1"]["tmp_name"], $UPLOAD_PATH . $fid);

			$result[0] = array("fid" => $fid,
							"fname" => $attachfiles["attach_file1"]["name"],
							"ftype" => $attachfiles["attach_file1"]["type"],
							"fsize" => $attachfiles["attach_file1"]["size"]);

		}

		if(isset($attachfiles["attach_file2"]) && $attachfiles["attach_file2"]["name"] != "" && $attachfiles["attach_file2"]["size"] > 0) {
			// 파일의 유일키 생성
			$fid = md5("board" . $this->id . $attachfiles["attach_file2"]["name"] . time());
			
			@move_uploaded_file($attachfiles["attach_file2"]["tmp_name"], $UPLOAD_PATH . $fid);

			$result[1] = array("fid" => $fid,
							"fname" => $attachfiles["attach_file2"]["name"],
							"ftype" => $attachfiles["attach_file2"]["type"],
							"fsize" => $attachfiles["attach_file2"]["size"]);

		}

		return $result;
	}

	////////////////////////////////////////
	// 업로드 파일 삭제
	////////////////////////////////////////
	function delete_file($fid) {
		if($fid == "") {
			return;
		}

		//$FILE_PATH = UPLOAD_BASE_PATH . "board" . $this->id . "/" . $fid;
		$FILE_PATH = "./data/board" . $this->id . "/" . $fid;

		if(@file_exists($FILE_PATH)) {
			@exec("rm -f " . $FILE_PATH);
		}
	}

	////////////////////////////////////////
	// 권한 검사
	////////////////////////////////////////
	function check_priv($mode, $auth, $no=0, $guest_no="", $is_notice="0", $is_secret="0") {

		if($mode == "LIST") {
			/* 목록보기모드 */
			
			if($auth->IsAuthenticated()) {
				if($auth->login_type == "A" || $this->member_priv & B_LIST) {
					return true;
				}
			} else {
				if($this->nobody_priv & B_LIST) {
					return true;
				}
			}

			return false;

		} else if($mode == "WRITE") {
			/* 쓰기모드 */

			if($auth->IsAuthenticated()) {
				if($auth->login_type == "A" || $this->member_priv & B_WRITE) {
					return true;
				}
			} else {
				if($this->nobody_priv & B_WRITE) {
					return true;
				}
			}

			return false;

		} else if($mode == "READ") {
			/* 읽기모드 */

			// 관리자는 읽기 가능
			if($auth->login_type == "A") {
				return true;
			}

			if($auth->IsAuthenticated()) {  // 로그인

				if($is_secret == "1" && $auth->guest_no == $guest_no) {
					// 비밀글인 경우 본인만 읽기 가능
					return true;
				} else if($this->member_priv & B_READ) {
					// 일반글인 경우
					return true;
				}

			} else {  // 비로그인

				if($is_secret == "1" && isset($_COOKIE["BOARD"]["auth"]) && $_COOKIE["BOARD"]["auth"] == $no) {
					// 비밀글인 경우 본인만 읽기 가능
					return true;
				} else if($this->nobody_priv & B_READ) {
					// 일반글인 경우
					return true;
				}
			}

		} else if($mode == "REPLY") {
			/* 답변모드 */

			// 공지글은 답변 안됨
			if($is_notice == "1") {
				return false;
			}

			// 관리자는 읽기 가능
			if($auth->login_type == "A") {
				return true;
			}

			if($auth->IsAuthenticated()) {  // 로그인

				if($is_secret == "1" && $auth->guest_no == $guest_no) {
					// 비밀글인 경우 본인만 읽기 가능
					return true;
				} else if($this->member_priv & B_REPLY) {
					// 일반글인 경우
					return true;
				}

			} else {  // 비로그인

				if($is_secret == "1" && isset($_COOKIE["BOARD"]["auth"]) && $_COOKIE["BOARD"]["auth"] == $no) {
					// 비밀글인 경우 본인만 읽기 가능
					return true;
				} else if($this->nobody_priv & B_REPLY) {
					// 일반글인 경우
					return true;
				}
			}

		} else if($mode == "MODIFY") {
			/* 수정모드 */

			// 관리자는 수정 가능
			if($auth->login_type == "A") {
				return true;
			}

			// 회원이 작성한 글인 경우 본인 글이면 수정 가능
			if($guest_no != "" && $auth->guest_no == $guest_no) {
				return true;
			}

			// 비회원이 작성한 글인 경우 본인 글이면 수정 가능
			if($guest_no == "" && isset($_COOKIE["BOARD"]["auth"]) && $_COOKIE["BOARD"]["auth"] == $no) {
				return true;
			}

		} else if($mode == "DELETE") {
			/* 삭제모드 */

			// 관리자는 삭제 가능
			if($auth->login_type == "A") {
				return true;
			}

			// 회원이 작성한 글인 경우 본인 글이면 삭제 가능
			if($guest_no != "" && $auth->guest_no == $guest_no) {
				return true;
			}

			// 비회원이 작성한 글인 경우 본인 글이면 삭제 가능
			if($guest_no == "" && isset($_COOKIE["BOARD"]["auth"]) && $_COOKIE["BOARD"]["auth"] == $no) {
				return true;
			}

		} else if($mode == "COMMENT") {
			/* 코멘트 */

			if($is_notice == "1") {
				return false;
			}

			if($auth->IsAuthenticated()) {
				if($auth->login_type == "A" || $this->member_priv & B_COMMENT) {
					return true;
				}
			} else {
				if($this->nobody_priv & B_COMMENT) {
					return true;
				}
			}

		}

		return false;
	}

	////////////////////////////////////////
	// 페이지 네비게이션 출력
	////////////////////////////////////////
	function printNavigation($total, $limit=15, $pg=1) {

		global $sn, $ss, $sc, $keyword;
		
		$link_prefix = "list.php?id=" . $this->id . "&sn=" . $sn . "&ss=" . $ss . "&sc=" . $sc . "&keyword=" . urlencode(trim($keyword)) . "&pg=";

		if($total == 0) {
			return;
		}

		if($pg == "" || $pg == "0") {
			$pg = 1;
		}

		$path_info_tmp = explode("/", $_SERVER["SCRIPT_NAME"]);
		$url = $path_info_tmp[count($path_info_tmp) - 1];

		$pg_count = ceil($total / $limit);
		$start_pg = floor(($pg-1) / 10) * 10;
		$end_pg = $start_pg + 10;
		if($end_pg > $pg_count) {
			$end_pg = $pg_count;
		}

		if($pg > 1) {
			print "<a href=\"" . $link_prefix . "1\"" . $this->invisible_link() . "><IMG src=\"/images/qna/bbs_prev_end.gif\" width=11 height=11 align=absMiddle border=0></a>&nbsp;";
			print "<a href=\"" . $link_prefix . ($start_pg - 9) . "\"" . $this->invisible_link() . "><IMG src=\"/images/qna/bbs_prev.gif\" width=10 height=11 align=absMiddle border=0></a>&nbsp;";
		}

		for($i = $start_pg; $i < $end_pg; $i++) {
			if(($i+1) == $pg) {
				print "<FONT color=\"#f17533\"><strong>" . ($i+1) . "</strong></font>";
			} else {
				print "<a href=\"" . $link_prefix . ($i+1) . "\"" . $this->invisible_link() . ">" . ($i + 1) . "</a>";
			}

			if($i < $end_pg-1) {
				print " | ";
			}
		}

		if($end_pg < $pg_count) {
			print "&nbsp;<a href=\"" . $link_prefix . ($start_pg + 11) . "\"" . $this->invisible_link() . "><IMG src=\"/images/qna/bbs_next.gif\" width=10 height=11 align=absMiddle border=0></A>";  
			print "&nbsp;<a href=\"" . $link_prefix . $pg_count . "\"" . $this->invisible_link() . "><IMG src=\"/images/qna/bbs_next_end.gif\" width=11 height=11 border=0 align=absmiddle></a>";
		}
	}

	function invisible_link() {
		$script_str = " onmouseover=\"javascript:window.status='';return true;\" onmouseout=\"javascript:window.status='';return true;\"";

		return $script_str;
	}

	function filesize_format($size) {
		$ret = "";

		if($size < 1024) {
			$ret = $size . " Bytes";
		} else if(($size / 1024) < 1024) {
			$ret = round(($size / 1024), 2) . " KB";
		} else {
			$ret = round(($size / 1024 / 1024), 2) . "MB";
		}

		return $ret;
	}

}
?>