<?php
//
//    $Id: ip_det_list.php,v 1.1.1.1 2008/10/13 06:13:37 winchild Exp $
//
//    NAME: IP 목록
//    ARGUMENT:
//
//    DESCRIPTION:
//			DB에 입력되어 있는 IP의 모든 항목을 읽어와 한 페이지 당 ip_grp씩 출력한다.
//			맨 왼쪽에 있는 검색 창은 IP그룹을 선택하여 ip그룹에 따라 검색할 수 있도록 하였다.
//			출력 결과는 다음과 같은 항목들이며, 각 항목은 IP에 대한 정보를 나타낸다.
//			===================================================================================
//			IP			: IP
//			도메인		: 도메인명
//			사용용도	: IP 용도 
//			사용목적	: 사용목적
//			상태		: 상태
//			메모		: 
//			서비스번호	: IP를 사용하는 고객의 서비스번호
//			===================================================================================
//			IP를 추가할 때에는 오른쪽 위의 IP 추가 버튼을 이용하고, 
//			IP 내용을 수정할 때에는 IP의 고유아이디인 번호를 클릭한다.
//
//
//    TO DO:
//
//    REFERENCE:
//

	require_once("include/config.php");
	require_once("include/mysql.php");
	require_once("include/util.php");

	$mysql = new DB_Sql();
  	if ($mysql->connect("book") == 0)
	{
		PutLog (__FILE__,__LINE__,ERROR,"'book' DB Connect Faild:".$mysql->Error,TRUE);
		exit;
	}

	$query = "SELECT grid, ip_grp, start_ip, end_ip, mode FROM ip_grp ORDER BY ip_grp ASC";
	if (!$mysql->query($query)) {
		PutLog (__FILE__,__LINE__,ERROR,"SQL=[$query]".$mysql->Error,TRUE);
		$mysql->close();
//		goback("IP 그룹을 조회하는 도중 오류가 발생하였습니다.");
		exit;
	}

	if($mysql->nf() > 0) {
		$grp_no = 0;
		while ($mysql->next_record()) {
			$grid[$grp_no]		= $mysql->f("grid");
			$ip_grp[$grp_no]	= $mysql->f("ip_grp");
			$start_ip[$grp_no]	= $mysql->f("start_ip");
			$end_ip[$grp_no]	= $mysql->f("end_ip");
			$mode[$grp_no]		= $mysql->f("mode");
			$grp_no++;
		}
	}

	$remote_ip = $_SERVER["REMOTE_ADDR"];

	$query = "SELECT gid FROM ip_manager WHERE '".$remote_ip."'";
	if (!$mysql->query($query)) {
		PutLog (__FILE__,__LINE__,ERROR,"SQL=[$query]".$mysql->Error,TRUE);
		$mysql->close();
//		goback("IP 그룹을 조회하는 도중 오류가 발생하였습니다.");
		exit;
	}
	if($mysql->nf() > 0) {
		$mysql->next_record();
		$remote_ip_grp = $mysql->f("gid");
	}

	if( isset($_GET["ip"]) && $_GET["ip"] == "all" ) {
		$condition = "";
	} else if (isset($_GET["ip"]) && $_GET["ip"] != "") {
		$condition = " WHERE gid = '".$_GET["ip"]."'";
	} else {
		$condition = " WHERE gid = '".$remote_ip_grp."'";
	}

	if (!isset($_GET["order"]) || $_GET["order"] == "") {
		$orderby = " ORDER BY ip_idx ASC";

	} else {
		if (!isset($_GET["sort"]) || $_GET["sort"] == "") {
			$orderby = " ORDER BY sid ASC";

		} else {
			if ($_GET["order"] == "DESC") {
				$orderby = " ORDER BY " . $sort . " ASC";

			} else {
				$orderby = " ORDER BY " . $sort . " DESC";
			}
		}
	}

	$query = "SELECT grid, mode FROM ip_grp WHERE grid = '".$_GET["ip"]."'";
	if (!$mysql->query($query)) {
		PutLog (__FILE__,__LINE__,ERROR,"SQL=[$query]".$mysql->Error,TRUE);
		$mysql->close();
//		goback("IP 그룹을 조회하는 도중 오류가 발생하였습니다.");
		exit;
	}

	if($mysql->nf() > 0) {
		$mysql->next_record();
		$mode = $mysql->f("mode");
	}

	$query = "
			SELECT	sid, 
					gid, 
					reg_id, 
					ip, 
					domain, 
					expire_date, 
					customer_num,  
					category,  
					title,  
					status,  
					memo,
					use_id
			FROM	ip_manager 
					" . $condition . " 
					" . $orderby . " 
					" . $limit;

//echo "[$query]";
	if (!$mysql->query($query)) {
		$mysql->close();
		goback("IP 목록을 조회하는 도중 오류가 발생하였습니다.");
	}

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="expires" content="">
<title>▒ 삼정데이타서비스(주) ▒</title>
<link rel="stylesheet" type="text/css" href="include/css.css">
<script language="javascript" src="include/script.js"></script>
<script language="javascript" src="include/calendar_g.js"></script>
<script language="javascript" src="include/calendar-kor.js"></script>
<script language="javascript" src="include/calendar-setup.js"></script>
</head>
<body leftmargin=0 topmargin=0>
<?  require_once ("cacti_head.php"); ?>
<table width="98%" border="0" cellpadding="0" cellspacing="0" align="center">
	<tr valign="top">
		<td width="100%">
<br>

<!-- start title -->
<table width="100%" height="35" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td align="center" valign="bottom"><b>:: IP 내역 ::</b></td>
	</tr>
</table>
<br>
<!--// end title -->

<!-- start button -->
<table width="100%" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td>&nbsp;</td>
		<td width="60%">
			<select name="searchby" onchange="changeType2(this)">
			<option value=" ">IP 그룹 선택</option>
<?php
		for ( $i = 0; $i < $grp_no; $i++ ) {
?>
			<option value="<?=$grid[$i]?>"<?=($grid[$i] == $_GET["ip"] ? "selected":"")?>><?=$ip_grp[$i]?>.<?=$start_ip[$i]?>~<?=$end_ip[$i]?></option>
<?php
	} 
?>
			<option value="all">전체 보기</option>
			</select>
		</td>
		<td width="40%" align="right"><input type="button" value="IP 대역 목록" class="bttn" onclick="javascript:gotoPage('./ip_list.php')">&nbsp;
		<input type="button" value="IP 추가" class="bttn" onclick="javascript:add_ip(<?=($_GET['ip'] ? $_GET['ip']:$remote_ip_grp)?>)">
		<input type="button" value="본IP 전체삭제" class="bttn" onclick="javascript:del_ip(<?=($_GET['ip'] ? $_GET['ip']:$remote_ip_grp)?>)"></td>
	</tr>
</table><br>
<!--// end button -->

<!-- start list -->
<table width="100%" border="0" cellpadding="3" cellspacing="1" bgcolor="#506E8E">
<?php
	if ( $mode == 'SERVICE') {
?>
		<tr height="25" align="center" bgcolor="#6B92BD">

				<!-- IP -->
			<td width="10%" class="title">IP</td>

				<!-- 서비스번호 -->
			<td width="10%" class="title">서비스번호</td>

				<!-- 사용목적 -->
			<td width="10%" class="title">사용목적</td>

				<!-- 상태  -->
			<td width="10%" class="title">상태 </td>

				<!-- 메모 -->
			<td width="20%" class="title">메모</td>

		</tr>
<?php
	} else {
?>
		<tr height="25" align="center" bgcolor="#6B92BD">

				<!-- IP -->
			<td width="10%" class="title">IP</td>

				<!-- 도메인 -->
			<td width="10%" class="title">도메인</td>

				<!-- 사용용도 /-->
			<td width="15%" class="title">사용용도</td>

				<!-- 메모 -->
			<td width="22%" class="title">메모</td>

				<!-- 사용자 -->
			<td width="6%" class="title">사용자</td>

		</tr>
<?php
	}
?>

<?php
	$total_count = 0;
	$used_count = 0;
	if($mysql->nf() > 0) {
		while($mysql->next_record()) {

			$total_count++;
			if ($mysql->f("title") != "") $used_count++;

			if ($bg_color == "#EEF1F5") $bg_color = "#fffacd";
			else $bg_color = "#EEF1F5";

?>
			<tr height="22" onmouseover=this.style.backgroundColor='#ffffff'
				onmouseout=this.style.backgroundColor='' bgColor="<?=$bg_color?>">

				<td align="center" style="cursor:hand"><a
				href="javascript:modify_ip('<?=($mysql->f(sid))?>')"><?=($mysql->f("ip"))?></a></td>
<?php
			if ( $mode == 'SERVICE') {
?>
				<td align="center"><?=($mysql->f("customer_num"))?></td>
				<td align="center"><?=($mysql->f("category"))?></td>
				<td align="left"  ><?=($mysql->f("status"))?></td>
				<td align="left"  ><?=($mysql->f("memo"))?></td>
<?php
			} else {
?>
				<td align="center"><?=($mysql->f("domain"))?></td>
				<td align="center"><?=($mysql->f("title"))?></td>
				<td align="left">
<?php
				if ( strlen($mysql->f("memo")) > 36 ) {
					$tmp_memo = substr( ($mysql->f("memo")), 0, 36);
?>
					<span style="cursor:hand"
						onmouseover="javascript:show_memo(memo<?=($mysql->f("sid"))?>, true)"
						onmouseout="javascript:show_memo(memo<?=($mysql->f("sid"))?>, false)">
						<img src="img/ico_file.gif">
						</span>
					<div id="memo<?=($mysql->f("sid"))?>" class="job_memo" align="left">
						<?=(nl2br(stripslashes(trim($mysql->f("memo")))))?>
					</div>
					<?=$tmp_memo?>...
<?php
				} else {
?>
					<?=(nl2br(stripslashes(trim($mysql->f("memo")))))?>
<?php
				}
?>
				</td>
<?php
				$item_mysql = new DB_Sql();
  				if ($item_mysql->connect("book") == 0)
				{
					PutLog (__FILE__,__LINE__,ERROR,"'book' DB Connect Faild:".$item_mysql->Error,TRUE);
					exit;
				}

				$item_query = "SELECT item.item_code, item.item_name 
						  FROM	computer 
						  LEFT OUTER JOIN item ON computer.item_sid = item.sid 
						  WHERE	computer.pc_ip = '" . $mysql->f("ip") . "'
						  ORDER BY computer.sid;
						 ";
				if (!$item_mysql->query($item_query)) {
					PutLog (__FILE__,__LINE__,ERROR,"SQL=[$query]".$item_mysql->Error,TRUE);
					$item_mysql->close();
//					goback("IP 그룹을 조회하는 도중 오류가 발생하였습니다.");
					exit;
				}

				if ( $mysql->f("use_id") ) {
					if($item_mysql->nf() > 0) {
?>
						<td align="center" style="cursor:hand" 
						onclick="javascript:add_computer('<?=($mysql->f("sid"))?>', '<?=($mysql->f("ip"))?>', 'MOD')"><?=($mysql->f("use_id"))?>
							<span 
								onmouseover="javascript:show_memo(memo<?=($mysql->f("sid"))?>_1, true)"
								onmouseout="javascript:show_memo(memo<?=($mysql->f("sid"))?>_1, false)">
								<img src="img/ico_file.gif">
								</span>
							<div id="memo<?=($mysql->f("sid"))?>_1" class="job_memo" align="left">
<?php
								while($item_mysql->next_record()) {
									switch ( $item_mysql->f("item_code") ) {
										case CPU_ :
?>
											CPU : <?=($item_mysql->f("item_name"))?></br> <?php
											break;

										case MEM_ :
?>
											MEM : <?=($item_mysql->f("item_name"))?></br> <?php
											break;

										case HDD_ :
?>
											HDD : <?=($item_mysql->f("item_name"))?></br> <?php
											break;

										case ODD_ :
?>
											ODD : <?=($item_mysql->f("item_name"))?></br> <?php
											break;

										case MON1 :
?>
											MONITOR1: <?=($item_mysql->f("item_name"))?></br> <?php
											break;

										case MON2 :
?>
											MONITOR2: <?=($item_mysql->f("item_name"))?></br> <?php
											break;

										default :
											break;
									}
								}
							} else {
?>
							<td align="center" style="cursor:hand" 
							onclick="javascript:add_computer('<?=($mysql->f("sid"))?>', '<?=($mysql->f("ip"))?>', 'ADD')"><?=($mysql->f("use_id"))?>
<?php
							}
							$item_mysql->close();
?>
							</div>
						</td>
<?php
				} else {
?>
					<td align="center"></td>
<?php
				}
			}
?>
			</tr>
<?php
		}
	} else {
		if( isset($_GET["ip"]) && $_GET["ip"] == "all" ) {
?>
			<tr height="25" bgcolor="#ffffff">
				<td colspan="7" align="center">등록된 IP가 없습니다.</td> 
			</tr>
<?php
		} else {
?>
			<tr height="25" bgcolor="#ffffff">
				<td colspan="7" align="center">검색된 IP가 없습니다.</td> 
			</tr>
<?php
		}
	}
?>

</table><br>
<!--// end list -->

<?php
	echo "전체갯수 = $total_count / 사용갯수 = $used_count </br>";

	$mysql->close();
?>

        </td>
    </tr>
</table>

<!--iframe name="tempFrame" frameborder="0" scrolling="0" src="null.html" style="position:absolute; visibility:hidden">
</iframe-->

</body>
</html>

