<?php
//
//    $Id: ip_grp_add.php,v 1.1.1.1 2008/10/13 06:13:37 winchild Exp $
//
//    NAME: IP 대역 등록
//    ARGUMENT:
//
//    DESCRIPTION:
//			새로운 IP 대역을 추가한다.
//
//			IP 대역 추가 버튼을 클릭하면 팝업창에 새로 등록할 IP에 대한 정보를 입력할 수 있다.
//			IP 대역 추가 시 해당 IP 그룹의 아이피 전부를 생성하여, DB에 저장한다.
//
//    TO DO:
//
//    REFERENCE:
//

	require_once("include/config.php");
	require_once("include/mysql.php");
	require_once("include/util.php");

	$mysql = new DB_Sql();
  	if ($mysql->connect("book") == 0)
	{
		PutLog (__FILE__,__LINE__,ERROR,"'book' DB Connect Faild:".$mysql->Error,TRUE);
		exit;
	}

	if (isset($_POST["act"]) && $_POST["act"] == "Y") {
		/***************************
		 * 데이터 유효성 검사
		 ***************************/
		if (!isset($_POST["ip_1"]) || $_POST["ip_1"] == "" || strlen($_POST["ip_1"]) > 3) {
			goback("IP명을 정확하게 입력해 주십시오.");
		}
		if (!isset($_POST["ip_2"]) || $_POST["ip_2"] == "" || strlen($_POST["ip_2"]) > 3) {
			goback("IP명을 정확하게 입력해 주십시오.");
		}
		if (!isset($_POST["ip_3"]) || $_POST["ip_3"] == "" || strlen($_POST["ip_3"]) > 3) {
			goback("IP명을 정확하게 입력해 주십시오.");
		}
		if (!isset($_POST["ip_4"]) || $_POST["ip_4"] == "" || strlen($_POST["ip_4"]) > 3) {
			goback("IP명을 정확하게 입력해 주십시오.");
		}
		if (!isset($_POST["ip_5"]) || $_POST["ip_5"] == "" || strlen($_POST["ip_5"]) > 3) {
			goback("IP명을 정확하게 입력해 주십시오.");
		}
		if ( $_POST["ip_4"] > $_POST["ip_5"] ) {
			goback("IP 대역을 정확하게 입력해 주십시오.");
		}

		$reg_id		= trim($_POST["reg_id"]);
		$ip			= trim($_POST["ip"]);
		$others		= trim($_POST["others"]);
		$mode		= trim($_POST["mode"]);
	
		$wk_id		= $_SERVER["PHP_AUTH_USER"];
		$use_id		= trim($_POST["use_id"]);

		$ip_1		= trim($_POST["ip_1"]);
		$ip_2		= trim($_POST["ip_2"]);
		$ip_3		= trim($_POST["ip_3"]);
		$ip_4		= trim($_POST["ip_4"]);
		$ip_5		= trim($_POST["ip_5"]);

		$ip_grp		= $ip_1.".".$ip_2.".".$ip_3;
		$ip_count	= $ip_5 - $ip_4;
		
		$sub_mask_1	= trim($_POST["sub_mask_1"]);
		$sub_mask_2	= trim($_POST["sub_mask_2"]);
		$sub_mask_3	= trim($_POST["sub_mask_3"]);
		$sub_mask_4	= trim($_POST["sub_mask_4"]);
		$sub_mask	= $sub_mask_1.".".$sub_mask_2.".".$sub_mask_3.".".$sub_mask_4;

		$gateway_1	= trim($_POST["gateway_1"]);
		$gateway_2	= trim($_POST["gateway_2"]);
		$gateway_3	= trim($_POST["gateway_3"]);
		$gateway_4	= trim($_POST["gateway_4"]);
		$gateway	= $gateway_1.".".$gateway_2.".".$gateway_3.".".$gateway_4;

		/***************************
		* INSERT & SELECT (ip_grp) *
		****************************/

		$query = "	SELECT	ip_grp, start_ip, end_ip
					FROM	ip_grp 
					WHERE	ip_grp = '" . $ip_grp  . "'
				 ";
		if (!$mysql->query($query)) {
			$mysql->close();
			goback("IP 등록 도중 오류가 발생하였습니다.");
		}

		if ($mysql->nf() > 0) {
			$arr = 0;
			while ($mysql->next_record()) {
				$start_ip[$arr]	= $mysql->f("start_ip");
				$end_ip[$arr]	= $mysql->f("end_ip");
				$arr++;
			} 

			for ( $arr_count = 0; $arr_count < $arr; $arr_count++ ) {
				$ip_flag = 1;
				// 이 대역에 속해 있는 지 아닌지 확인
				if ( ($start_ip[$arr_count] <= $ip_4) && ($ip_4 <= $end_ip[$arr_count]) ) {

					// $ip_4 가 기존의 IP 대역폭 안에 있을 때

					if ( ($start_ip[$arr_count] <= $ip_5) && ($ip_5 <= $end_ip[$arr_count]) ) {
						// 1. $ip_5 가 기존의 IP 대역폭 안에 있을 때
						$ip_flag = 0;
						alert("이미 등록된 IP 그룹과 IP 대역이 중복되어 IP그룹을 등록하지 않습니다");
						break;
					} else {
						// 2. $ip_5 가 기존의 IP 대역폭보다 클 때
						$ip_4 = $end_ip[$arr_count] + 1;
					}
				} else if ( $start_ip[$arr_count] > $ip_4 ) {
					// $ip_4 가 기존의 IP 대역폭보다 작을 때

					if ( $start_ip[$arr_count] > $ip_5 ) {

					} else if( $ip_5 <= $end_ip[$arr_count] ) {
						$ip_5 = $start_ip[$arr_count] - 1;	
					} else {
						goback("이미 등록된 IP 대역과 중복됩니다. 다시 확인하시고 정확하게 입력하세요");
						break;
					}
				} else {
					// $ip_4 가 기존의 IP 대역폭보다 클 때
				}
			} // for

			if ( $ip_flag ) {
				alert($ip_4 ."부터  ". $ip_5 ."까지 새 IP 그룹에 등록합니다");

				$query = "
						INSERT INTO ip_grp ( 
									ip_grp, 
									start_ip, 
									end_ip, 
									others,
									mode,
									ts, 
									wk_id 
						) VALUES ( 
									'" . $ip_grp . "' ,
									'" . $ip_4 . "' ,
									'" . $ip_5 . "' ,
									'" . $others . "' ,
									'" . $mode . "' ,
									now(),
									'" . $wk_id . "' 
						)";
				
				if (!$mysql->query($query)) {
					$mysql->close();
					goback("IP 카테고리 등록 도중 오류가 발생하였습니다.");
				}
			}
		} else {

			$query = "
					INSERT INTO ip_grp ( 
								ip_grp, 
								start_ip, 
								end_ip, 
								others,
								mode,
								ts, 
								wk_id 
					) VALUES ( 
								'" . $ip_grp . "' ,
								'" . $ip_4 . "' ,
								'" . $ip_5 . "' ,
								'" . $others . "' ,
								'" . $mode . "' ,
								now(),
								'" . $wk_id . "' 
					)";
			
			if (!$mysql->query($query)) {
				$mysql->close();
				goback("IP 카테고리 등록 도중 오류가 발생하였습니다.");
			}
		}

		$query = "
				SELECT	ip_grp.grid  FROM book.ip_grp 
				WHERE	ip_grp.ip_grp = '" . $ip_grp  . "'
					AND	CAST(ip_grp.start_ip AS UNSIGNED) <= '" . $ip_4 . "' AND CAST(ip_grp.end_ip AS UNSIGNED) >= '" . $ip_5 . "'
				";
		
		if (!$mysql->query($query)) {
			$mysql->close();
			goback("IP 카테고리 검색 도중 오류가 발생하였습니다.");
		}
		$mysql->next_record();
		$gid = $mysql->f("grid");

		for ( $i = 0; $i <= $ip_count; $i++) {

			$ip = $ip_grp.".".$ip_4;

			$query = " SELECT ip FROM ip_manager WHERE ip = '" . $ip . "'";
			if (!$mysql->query($query)) {
				$mysql->close();
				goback("IP 등록 도중 오류가 발생하였습니다.");
			}

			if ($mysql->nf() > 0) {
				$mysql->close();
				closewin("이미 등록된 IP와 중복되어 IP를 등록하지 않고 현재 창을 닫습니다");
			}

			/**************************
			* INSERT INTO TABLE       *
			**************************/

			$query = "
					INSERT INTO ip_manager (
								gid, reg_id, ip, sub_mask, gateway, ts, wk_id
					) VALUES (
								'" . $gid . "',
								'" . $wk_id . "',
								'" . $ip . "', 
								'" . $sub_mask . "', 
								'" . $gateway . "', 
								now(),
								'" . $wk_id . "'
					)";

			if (!$mysql->query($query)) {
				$mysql->close();
				goback("IP 등록 도중 오류가 발생하였습니다.");
			}
			if ($ip_4 == $ip_5)
				break;
			$ip_4++;
		}

		$mysql->close();
		$ip_count += 1;
		reload_opener(" $ip_count 개의 IP가 등록되었습니다.");

	} else {
/*
		$query = "SELECT name 
				  FROM   intranet.t_user 
				  WHERE  id = '" . $_SERVER["PHP_AUTH_USER"] . "'";

		if (!$mysql->query($query)) {
			$mysql->close();
			closewin("세션 사용자 정보 조회 도중 오류가 발생하였습니다.");
		}

		if ($mysql->nf() == 0) {
			$mysql->close();
			closewin("세션 사용자 정보를 찾을 수 없습니다.");
		}

		$mysql->next_record();
		$worker      = $_SERVER["PHP_AUTH_USER"];
		$worker_name = $mysql->f("name");
*/
	}
?>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>IP 대역 등록</title>
<link rel="stylesheet" type="text/css" href="include/css.css">
<script language="javascript" src="include/script.js"></script>
<script language="javascript">

	function init_document(form) {
			form.ip_1.focus();
	}

	function check_data(form) {

		if (form.ip_1.value == "" || form.ip_1.value >= 256 || form.ip_1.value < 0 ) {
			alert("IP명을 정확하게 입력해 주십시오.");
			form.ip_1.focus();
			return false;
		}
		if (form.ip_2.value == "" || form.ip_2.value >= 256 || form.ip_2.value < 0 ) {
			alert("IP명을 정확하게 입력해 주십시오.");
			form.ip_2.focus();
			return false;
		}
		if (form.ip_3.value == "" || form.ip_3.value >= 256 || form.ip_3.value < 0 ) {
			alert("IP명을 정확하게 입력해 주십시오.");
			form.ip_3.focus();
			return false;
		}
		if (form.ip_4.value == "" || form.ip_4.value >= 256 || form.ip_4.value < 0) {
			alert("IP명을 정확하게 입력해 주십시오.");
			form.ip_4.focus();
			return false;
		}
		if (form.ip_5.value == "" || form.ip_5.value >= 256 || form.ip_5.value < 0 ) {
			alert("IP명을 정확하게 입력해 주십시오.");
			form.ip_5.focus();
			return false;
		}

		return true;
	}
</script>
</head>


<body bgcolor="#f8f8f8" onload="javascript:init_document(document.forms[0])">

<form name="book_add" method="post" onsubmit="javascript:return check_data(this)">
<input type="hidden" name="act"        value="Y">

<table width="90%" border="0" cellpadding="3" cellspacing="0" align="center">
	<tr>
		<td colspan="3"><b>:: IP 대역 등록 ::</b></td>
	</tr>
	<tr>
		<td colspan="3" height="5">&nbsp;</td>
	</tr>
	<tr>
		<td colspan="3" style="border-top-style:dashed; border-top-width:1px; border-top-color:#c8c8c8">&nbsp;</td>
	</tr>
	<tr>
		<td align="right">IP</td>
		<td><font color="#c8c8c8">|</font></td>
		<td><input type="text" name="ip_1" size="3" class="box">.
			<input type="text" name="ip_2" size="3" class="box">.
			<input type="text" name="ip_3" size="3" class="box">.
			<input type="text" name="ip_4" size="3" class="box">&nbsp;~&nbsp;
			<input type="text" name="ip_5" size="3" class="box"></td>
	</tr>
	<tr>
		<td align="right">서브넷 마스크</td>
		<td><font color="#c8c8c8">|</font></td>
		<td><input type="text" name="sub_mask_1" size="3" class="box">.
			<input type="text" name="sub_mask_2" size="3" class="box">.
			<input type="text" name="sub_mask_3" size="3" class="box">.
			<input type="text" name="sub_mask_4" size="3" class="box"></td>
	</tr>
	<tr>
		<td align="right">게이트웨이</td>
		<td><font color="#c8c8c8">|</font></td>
		<td><input type="text" name="gateway_1" size="3" class="box">.
			<input type="text" name="gateway_2" size="3" class="box">.
			<input type="text" name="gateway_3" size="3" class="box">.
			<input type="text" name="gateway_4" size="3" class="box"></td>
	</tr>
<?php
			$query = "
					SELECT cat_name, CASE cat_name WHEN '기타' THEN 'A'  END C
					FROM   book.ip_category
					ORDER BY C, cat_name;
					 ";

			if (!$mysql->query($query)) {
				$mysql->close();
				closewin("카테고리 목록 구성 중 오류가 발생하였습니다.");
			}

			if ($mysql->nf() > 0) {
				for ( $i = 0; $mysql->next_record(); $i++ ) {
					$cat_name[$i] = $mysql->f("cat_name");
				}
			}
?>
	<tr>
		<td align="right">사용목적</td>
		<td><font color="#c8c8c8">|</font></td>
		<td>
			<select name="category" >
			<option value=""></option>
<?php
		for ( $j = 0; $j < $i; $j++ ) {
?>
			<option value="<?=$cat_name[$j]?>"><?=$cat_name[$j]?></option>
<?php
		}
?>
			</select>
		</td>
	</tr>

	<tr>
		<td align="right">템플릿 선택</td>
		<td><font color="#c8c8c8">|</font></td>
		<td><input type="radio" name="mode" value="SERVICE" checked>서비스용&nbsp;&nbsp;&nbsp;
		<input type="radio" name="mode" value="COMPANY" checked>사내용</td>
	</tr>

	<tr>
		<td align="right">비고</td>
		<td><font color="#c8c8c8">|</font></td>
		<td><textarea name="others" cols="30" rows="3" class="box"></textarea></td>
	</tr>

	<tr>
		<td colspan="3" height="5">&nbsp;</td>
	</tr>
	<tr>
		<td colspan="3" style="border-top-style:dashed; border-top-width:1px; border-top-color:#c8c8c8">&nbsp;</td>
	</tr>

	<tr>
		<td colspan="3" align="center"><input type="submit" value="등록" class="bttn">&nbsp;<input 
		type="button" value="닫기" class="bttn" onclick="self.close()"></td>
	</tr>
</table>
</form>
</body>
</html>
<?php
	$mysql->close();
?>

