--
-- $Id: nms.sql,v 1.1.1.1 2008/10/13 06:13:37 winchild Exp $
--
-- 상정데이터서비스 NMS 커스텀 테이블

--
-- Table structure for table `gls`
--

DROP TABLE IF EXISTS `gls`;
CREATE TABLE `gls` (
  `sid` int(11) NOT NULL auto_increment,
  `tab_sid` int(11) default NULL,			# tab.sid
  `gid` int(11) NOT NULL,					# graphic id
  `ov_limit` int(11) default NULL,			# 허용 트래픽용량 - 고객의 계약용량과는 다름.
  `wkid` varchar(6) NOT NULL default '',
  `ts` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`sid`),
  UNIQUE KEY `gid` (`gid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Table structure for table `account`
--
-- HSM DB 와 동기화 하는 데이터

DROP TABLE IF EXISTS `account`;
CREATE TABLE `account` (
  `sid` int(11) NOT NULL auto_increment,
  `gid` int(11) NOT NULL,					# 그래픽 id
  `ip` varchar(16) NOT NULL,				# 고객서버 IP
  `svc_no` varchar(6) NOT NULL default '',	# 서비스#
  `name` tinytext,							# 고객명
  `wkid` varchar(6) NOT NULL default '',
  `ts` datetime NOT NULL default '0000-00-00 00:00:00',
  `limit_cnt` int(11) default NULL,			# 계약용량
  `pause` enum('Y','N') default 'N',		# 보류여부
  PRIMARY KEY  (`sid`),
  UNIQUE KEY `gid` (`gid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Table structure for table `ov_trff_pri`
--
-- 초과된 포트를 찾기위해서 스캐닝 작업을 하는 상위테이블

DROP TABLE IF EXISTS `ov_trff_pri`;
CREATE TABLE `ov_trff_pri` (
  `sid` int(11) NOT NULL auto_increment,
  `ts` datetime NOT NULL default '0000-00-00 00:00:00',	# 스캐닝시간
  PRIMARY KEY  (`sid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Table structure for table `ov_trff`
--
-- 초과된 포트의 테이블 input/output의 둘중의 하나만 초과해도 insert

DROP TABLE IF EXISTS `ov_trff`;
CREATE TABLE `ov_trff` (
  `sid` int(11) NOT NULL auto_increment,
  `gid` int(11) NOT NULL,				# 그래픽 ID
  `pid` int(11) NOT NULL,				# ov_trff_pri.sid
  `ov_in` int(11) default NULL,			# 초과된 트래픽 input
  `ov_out` int(11) default NULL,		# 초과된 트래픽 output
  PRIMARY KEY  (`sid`),
  KEY `gid` (`gid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Table structure for table `tab`
--
-- 모니터링 페이지의 분류탭

DROP TABLE IF EXISTS `tab`;
CREATE TABLE `tab` (
  `sid` int(11) NOT NULL auto_increment,
  `name` tinytext,
  `gsum` enum('Y','N') default 'N',			# 해당탭의 합산그래프여부
  `ov_alarm` enum('Y','N') default 'N',		# 초과시에 알람을 할것인가의 여부 (메일리포트)
  `sms_alarm` enum('Y','N') default 'N',	# 초과시에 개별로 SMS 알람을 할것인가의 여부
  `col` int(11) NOT NULL default '2',		# 컬럼수
  `dur` int(11) NOT NULL default '24',		# 간격, 시간단위, 보통 24시간단위임.
  `wkid` varchar(6) NOT NULL default '',
  `ts` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`sid`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

--
-- Table structure for table `sj_setting`
--
-- SMS/MAIL 등의 부가적인 정보를 수록

DROP TABLE IF EXISTS `sj_setting`;
CREATE TABLE `sj_setting` (
  `name` varchar(32) NOT NULL,
  `value` varchar(32) NOT NULL,
  PRIMARY KEY  (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `sj_sms`;
CREATE TABLE `sj_sms` (
  `phone` varchar(20) UNIQUE NOT NULL,
  `week` INT NOT NULL,						# 일별 마스킹
  `st_tm` TIME NOT NULL,					# 발송가능 시각
  `et_tm` TIME NOT NULL,					# 발송종료 시각
  `pause` enum('Y','N') default 'N',		# 발송중지 플래그
  PRIMARY KEY  (`phone`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Table structure for table `sj_memo`
--
-- 작업자가 남겨놓는 메모

DROP TABLE IF EXISTS `sj_memo`;
CREATE TABLE `sj_memo` (
  `sid` int(11) NOT NULL auto_increment,
  `tab_sid` int(11) default NULL,			# tab.sid
  `memo` tinytext NOT NULL,					# 메모
  `wkid` varchar(6) NOT NULL default '',
  `ts` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`sid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Table structure for table `vlan_desc`
--
-- L3 스위치의 VLAN 구획설정

DROP TABLE IF EXISTS `vlan_desc`;
CREATE TABLE `vlan_desc` (
  `l3_ip` varchar(16) NOT NULL default '',
  `vlan` int(11) default NULL,			# tab.sid
  `base_ip` varchar(16) NOT NULL default '',
  `mask` varchar(16) NOT NULL default '',
  `wkid` varchar(6) NOT NULL default '',
  `ts` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY (`l3_ip`,`vlan`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

