<?php
//
//  $Id: ws_nwnms.php,v 1.1.1.1 2008/10/13 06:13:37 winchild Exp $
//
//	NAME:
//	ARGUMENT:
//	DESCRIPTION:
//
//	REFERENCE:
//
//		mysql> desc host;
//		+--------------------+-----------------------+------+-----+---------------------+----------------+
//		| Field              | Type                  | Null | Key | Default             | Extra          |
//		+--------------------+-----------------------+------+-----+---------------------+----------------+
//		| id                 | mediumint(8) unsigned | NO   | PRI | NULL                | auto_increment |
//		| host_template_id   | mediumint(8) unsigned | NO   |     | 0                   |                |
//		| description        | varchar(150)          | NO   |     |                     |                |
//		| hostname           | varchar(250)          | YES  |     | NULL                |                |
//		| snmp_community     | varchar(100)          | YES  |     | NULL                |                |
//		| snmp_version       | tinyint(1) unsigned   | NO   |     | 1                   |                |
//		| snmp_username      | varchar(50)           | YES  |     | NULL                |                |
//		| snmp_password      | varchar(50)           | YES  |     | NULL                |                |
//		| snmp_port          | mediumint(5) unsigned | NO   |     | 161                 |                |
//		| snmp_timeout       | mediumint(8) unsigned | NO   |     | 500                 |                |
//		| disabled           | char(2)               | YES  |     | NULL                |                |
//		| status             | tinyint(2)            | NO   |     | 0                   |                |
//		| status_event_count | mediumint(8) unsigned | NO   |     | 0                   |                |
//		| status_fail_date   | datetime              | NO   |     | 0000-00-00 00:00:00 |                |
//		| status_rec_date    | datetime              | NO   |     | 0000-00-00 00:00:00 |                |
//		| status_last_error  | varchar(50)           | YES  |     |                     |                |
//		| min_time           | decimal(10,5)         | YES  |     | 9.99999             |                |
//		| max_time           | decimal(10,5)         | YES  |     | 0.00000             |                |
//		| cur_time           | decimal(10,5)         | YES  |     | 0.00000             |                |
//		| avg_time           | decimal(10,5)         | YES  |     | 0.00000             |                |
//		| total_polls        | int(12) unsigned      | YES  |     | 0                   |                |
//		| failed_polls       | int(12) unsigned      | YES  |     | 0                   |                |
//		| availability       | decimal(8,5)          | NO   |     | 100.00000           |                |
//		+--------------------+-----------------------+------+-----+---------------------+----------------+
//		
//		mysql> desc graph_local;
//		+-------------------+-----------------------+------+-----+---------+----------------+
//		| Field             | Type                  | Null | Key | Default | Extra          |
//		+-------------------+-----------------------+------+-----+---------+----------------+
//		| id                | mediumint(8) unsigned | NO   | PRI | NULL    | auto_increment |
//		| graph_template_id | mediumint(8) unsigned | NO   | MUL | 0       |                |
//		| host_id           | mediumint(8) unsigned | NO   | MUL | 0       |                |
//		| snmp_query_id     | mediumint(8)          | NO   |     | 0       |                |
//		| snmp_index        | varchar(255)          | NO   | MUL |         |                |
//		+-------------------+-----------------------+------+-----+---------+----------------+
//	
//

require_once("../include/config.php");
require_once("DIRECTLIB/adodb/adodb.inc.php");
require_once("DIRECTLIB/include/db.php");


if (isset($_POST['CMD'])) {
	$in_cmd = $_POST['CMD'];
} else {
	if (isset($_GET['CMD'])) {
		$in_cmd = $_GET['CMD'];
	}
}

if (isset($_POST['PARAM'])) {
	$in_param = $_POST['PARAM'];
} else {
	if (isset($_GET['PARAM'])) {
		$in_param = $_GET['PARAM'];
	}
}

if (isset($_POST['IP'])) {
	$ip_param = $_POST['IP'];
} else {
	if (isset($_GET['IP'])) {
		$ip_param = $_GET['IP'];
	}
	else $ip_param = "";
}

if (empty($in_cmd)) {
	error_ret ('not found CMD');
}

switch (strtoupper($in_cmd)) {
	case 'CHKIPPORT':
		check_ip_port($in_param);
		break;
	case 'GETHOST':
		get_host_info($ip_param);
		break;
	case 'GETPORT':
		get_port_info($in_param);
		break;
	case 'GETOVERTRAFFIC':
		get_over_traffic($in_param);
		break;
	default:
		error_ret ('not match CMD : '.$in_cmd);
		break;
}

//	DB 
//
function get_db_ref() {
	$conn = db_conn("mysql", "localhost", "cactiuser", "cacti", "cacti");
	return $conn;
}

//	IP & PORT check
//
function check_ip_port ($param) {

	$query = "SELECT b.title_cache,c.hostname FROM graph_local a, graph_templates_graph b, host c
            WHERE c.id=a.host_id AND a.id=b.local_graph_id AND b.local_graph_id='$param'";

	$db = get_db_ref();
	$ret = get_array($db, $query);


	close_db($db);

	if ($ret) {
		$port = substr ($ret[0]["title_cache"], strrpos ($ret[0]["title_cache"],'-')+2);
		create_ret_xml ("OK", "", "", "", $param, $ret[0]["hostname"], $port);
	} else {
		// error message euc-kr used.
		create_ret_xml ("OK", "", "", "", "", "", "", "NMS IP PORT ã  ϴ");
	}
}

//	ȣƮ FETCH
//
function get_host_info ($ip) {

	$pos = strrpos ($ip,".");
	if ($pos !== FALSE) $ip = substr ($ip, 0, $pos);

	$query = "SELECT id, hostname, description
		FROM host WHERE hostname like '$ip%'";

	$db = get_db_ref();
	$ret = get_array($db, $query);
	close_db($db);
	
	if ($ret) {
		$opt_str = create_options ($ret, 'description', 'hostname', FALSE);	
		success_ret ("host", $opt_str);
	} else {
		success_ret ("host", "<option value=''></option>");
	}
}

function create_options($arr_data, $text, $value, $cut_opt) {

	$ret = "<option value=''></option>";

	foreach ($arr_data as $item) {
		if ($cut_opt == FALSE)
		{
			$opt = $item[$text];
		}
		else
		{
			$pos = strrpos ($item[$text],"-");
			if ($pos === FALSE) $opt = $item[$text];
			else $opt = substr ($item[$text], $pos+2);
		}
		$ret .= "<option value=\"".$item[$value]."\">".$opt."</option>\r\n";	
	}

	return $ret;
}

function get_over_traffic($param) {
	$query = "
	SELECT
		(CASE 
			WHEN ifnull(ov_in,0) > ifnull(ov_out,0) 
			THEN ifnull(ov_in,0) 
			ELSE ifnull(ov_out,0) 
		END) as 'ov_size'
	FROM 
		ov_trff 
	WHERE 
		gid=?
	ORDER BY 
		pid DESC 
	LIMIT 1
	";

	$parm[] = $param[0];

	$db = get_db_ref();
	$ret = get_records($db, $query, $parm);
	close_db($db);
	
	if ($ret) {
		success_ret_s ($ret['ov_size']);
	} else {
		success_ret_s ("0");
	}
}

//	Ʈ FETCH
//
function get_port_info($param) {

	$query = "SELECT a.id, b.title_cache
        FROM graph_local a, graph_templates_graph b
	WHERE
		a.host_id=(select id from host where hostname='".$param[0]."') AND 
		b.local_graph_id=a.id AND
		b.title_cache LIKE '%Traffic%'
        ";

        $db = get_db_ref();
        $ret = get_array($db, $query);
        close_db($db);

        if ($ret) {
           	$opt_str = create_options ($ret, 'title_cache', 'id', TRUE);
                success_ret ("port", $opt_str);
        } else {
		success_ret ("port", "<option value=''></option>");
        }

}

//	SELECT 
//
function create_ret_xml($ret, $msg, $select_name="", $select_value="", $gid="", $ip="", $port="", $comment="") {
	header ("Content-type: text/xml; charset=euc-kr");

	$cmd_body  = "<?xml version=\"1.0\" encoding=\"euc-kr\"?>\r\n";
	$cmd_body .= "<HSMDATA>\r\n";
	$cmd_body .= "<RET>".$ret."</RET>\r\n";
	$cmd_body .= "<MSG><![CDATA[".$msg."]]></MSG>\r\n";
	if (!empty($select_name)) {
		$cmd_body .= "<SELECT NAME=\"".$select_name."\"><![CDATA[".$select_value."]]></SELECT>";
	}
	if (!empty($gid)) {
		$cmd_body .= "<COLUMN NAME=\"gid\"><![CDATA[".$gid."]]></COLUMN>\r\n";
	}
	if (!empty($ip)) {
		$cmd_body .= "<COLUMN NAME=\"ip\"><![CDATA[".$ip."]]></COLUMN>\r\n";
	}
	if (!empty($port)) {
		$cmd_body .= "<COLUMN NAME=\"port\"><![CDATA[".$port."]]></COLUMN>\r\n";
	}
	if (!empty($comment)) {
		$cmd_body .= "<COLUMN NAME=\"msg\"><![CDATA[".$comment."]]></COLUMN>\r\n";
	}
	$cmd_body .= "</HSMDATA>";

	echo $cmd_body;
	exit;
}

function error_ret($msg) {
	create_ret_xml ("FAIL", $msg);
}

function success_ret($s_name, $s_val) {
	create_ret_xml ("OK", "", $s_name, $s_val);	
}

function success_ret_s($msg) {
	create_ret_xml ("OK", $msg);
}
?>
